#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """
CiMgVmVyc2lvbjogMC4xOC4xCgoiIiJUaGUgVmVyc2lvbmVlciAtIGxpa2Ug
YSByb2NrZXRlZXIsIGJ1dCBmb3IgdmVyc2lvbnMuCgpUaGUgVmVyc2lvbmVl
cgo9PT09PT09PT09PT09PQoKKiBsaWtlIGEgcm9ja2V0ZWVyLCBidXQgZm9y
IHZlcnNpb25zIQoqIGh0dHBzOi8vZ2l0aHViLmNvbS93YXJuZXIvcHl0aG9u
LXZlcnNpb25lZXIKKiBCcmlhbiBXYXJuZXIKKiBMaWNlbnNlOiBQdWJsaWMg
RG9tYWluCiogQ29tcGF0aWJsZSBXaXRoOiBweXRob24yLjYsIDIuNywgMy4y
LCAzLjMsIDMuNCwgMy41LCAzLjYsIGFuZCBweXB5CiogWyFbTGF0ZXN0IFZl
cnNpb25dCihodHRwczovL3B5cGlwLmluL3ZlcnNpb24vZmRucy12ZXJzaW9u
ZWVyL2JhZGdlLnN2Zz9zdHlsZT1mbGF0KQpdKGh0dHBzOi8vcHlwaS5weXRo
b24ub3JnL3B5cGkvZmRucy12ZXJzaW9uZWVyLykKPT09PT09PQoqIENvbXBh
dGlibGUgd2l0aDogUHl0aG9uIDMuNiwgMy43LCAzLjgsIDMuOSBhbmQgcHlw
eTMKKiBbIVtMYXRlc3QgVmVyc2lvbl1bcHlwaS1pbWFnZV1dW3B5cGktdXJs
XQoKVGhpcyBpcyBhIHRvb2wgZm9yIG1hbmFnaW5nIGEgcmVjb3JkZWQgdmVy
c2lvbiBudW1iZXIgaW4gZGlzdHV0aWxzLWJhc2VkCnB5dGhvbiBwcm9qZWN0
cy4gVGhlIGdvYWwgaXMgdG8gcmVtb3ZlIHRoZSB0ZWRpb3VzIGFuZCBlcnJv
ci1wcm9uZSAidXBkYXRlCnRoZSBlbWJlZGRlZCB2ZXJzaW9uIHN0cmluZyIg
c3RlcCBmcm9tIHlvdXIgcmVsZWFzZSBwcm9jZXNzLiBNYWtpbmcgYSBuZXcK
cmVsZWFzZSBzaG91bGQgYmUgYXMgZWFzeSBhcyByZWNvcmRpbmcgYSBuZXcg
dGFnIGluIHlvdXIgdmVyc2lvbi1jb250cm9sCnN5c3RlbSwgYW5kIG1heWJl
IG1ha2luZyBuZXcgdGFyYmFsbHMuCgojIyBNb2RpZmllZCB2ZXJzaW9uCgpU
aGlzIHZlcnNpb24gd2FzIG1vZGlmaWVkIHRvIGFkZCB0aGUgcGVwNDQwLWlu
YyBzdHlsZSwgYXV0b21hdGljYWxseQppbmNyZW1lbnRpbmcgdGhlIG1pbm9y
IHZlcnNpb24KCiMjIFF1aWNrIEluc3RhbGwKCiogYHBpcCBpbnN0YWxsIHZl
cnNpb25lZXJgIHRvIHNvbWV3aGVyZSB0byB5b3VyICRQQVRICiogYWRkIGEg
YFt2ZXJzaW9uZWVyXWAgc2VjdGlvbiB0byB5b3VyIHNldHVwLmNmZyAoc2Vl
IGJlbG93KQoqIHJ1biBgdmVyc2lvbmVlciBpbnN0YWxsYCBpbiB5b3VyIHNv
dXJjZSB0cmVlLCBjb21taXQgdGhlIHJlc3VsdHMKCiMjIFZlcnNpb24gSWRl
bnRpZmllcnMKClNvdXJjZSB0cmVlcyBjb21lIGZyb20gYSB2YXJpZXR5IG9m
IHBsYWNlczoKCiogYSB2ZXJzaW9uLWNvbnRyb2wgc3lzdGVtIGNoZWNrb3V0
IChtb3N0bHkgdXNlZCBieSBkZXZlbG9wZXJzKQoqIGEgbmlnaHRseSB0YXJi
YWxsLCBwcm9kdWNlZCBieSBidWlsZCBhdXRvbWF0aW9uCiogYSBzbmFwc2hv
dCB0YXJiYWxsLCBwcm9kdWNlZCBieSBhIHdlYi1iYXNlZCBWQ1MgYnJvd3Nl
ciwgbGlrZSBnaXRodWIncwogICJ0YXJiYWxsIGZyb20gdGFnIiBmZWF0dXJl
CiogYSByZWxlYXNlIHRhcmJhbGwsIHByb2R1Y2VkIGJ5ICJzZXR1cC5weSBz
ZGlzdCIsIGRpc3RyaWJ1dGVkIHRocm91Z2ggUHlQSQoKV2l0aGluIGVhY2gg
c291cmNlIHRyZWUsIHRoZSB2ZXJzaW9uIGlkZW50aWZpZXIgKGVpdGhlciBh
IHN0cmluZyBvciBhIG51bWJlciwKdGhpcyB0b29sIGlzIGZvcm1hdC1hZ25v
c3RpYykgY2FuIGNvbWUgZnJvbSBhIHZhcmlldHkgb2YgcGxhY2VzOgoKKiBh
c2sgdGhlIFZDUyB0b29sIGl0c2VsZiwgZS5nLiAiZ2l0IGRlc2NyaWJlIiAo
Zm9yIGNoZWNrb3V0cyksIHdoaWNoIGtub3dzCiAgYWJvdXQgcmVjZW50ICJ0
YWdzIiBhbmQgYW4gYWJzb2x1dGUgcmV2aXNpb24taWQKKiB0aGUgbmFtZSBv
ZiB0aGUgZGlyZWN0b3J5IGludG8gd2hpY2ggdGhlIHRhcmJhbGwgd2FzIHVu
cGFja2VkCiogYW4gZXhwYW5kZWQgVkNTIGtleXdvcmQgKCRJZCQsIGV0YykK
KiBhIGBfdmVyc2lvbi5weWAgY3JlYXRlZCBieSBzb21lIGVhcmxpZXIgYnVp
bGQgc3RlcAoKRm9yIHJlbGVhc2VkIHNvZnR3YXJlLCB0aGUgdmVyc2lvbiBp
ZGVudGlmaWVyIGlzIGNsb3NlbHkgcmVsYXRlZCB0byBhIFZDUwp0YWcuIFNv
bWUgcHJvamVjdHMgdXNlIHRhZyBuYW1lcyB0aGF0IGluY2x1ZGUgbW9yZSB0
aGFuIGp1c3QgdGhlIHZlcnNpb24Kc3RyaW5nIChlLmcuICJteXByb2plY3Qt
MS4yIiBpbnN0ZWFkIG9mIGp1c3QgIjEuMiIpLCBpbiB3aGljaCBjYXNlIHRo
ZSB0b29sCm5lZWRzIHRvIHN0cmlwIHRoZSB0YWcgcHJlZml4IHRvIGV4dHJh
Y3QgdGhlIHZlcnNpb24gaWRlbnRpZmllci4gRm9yCnVucmVsZWFzZWQgc29m
dHdhcmUgKGJldHdlZW4gdGFncyksIHRoZSB2ZXJzaW9uIGlkZW50aWZpZXIg
c2hvdWxkIHByb3ZpZGUKZW5vdWdoIGluZm9ybWF0aW9uIHRvIGhlbHAgZGV2
ZWxvcGVycyByZWNyZWF0ZSB0aGUgc2FtZSB0cmVlLCB3aGlsZSBhbHNvCmdp
dmluZyB0aGVtIGFuIGlkZWEgb2Ygcm91Z2hseSBob3cgb2xkIHRoZSB0cmVl
IGlzIChhZnRlciB2ZXJzaW9uIDEuMiwgYmVmb3JlCnZlcnNpb24gMS4zKS4g
TWFueSBWQ1Mgc3lzdGVtcyBjYW4gcmVwb3J0IGEgZGVzY3JpcHRpb24gdGhh
dCBjYXB0dXJlcyB0aGlzLApmb3IgZXhhbXBsZSBgZ2l0IGRlc2NyaWJlIC0t
dGFncyAtLWRpcnR5IC0tYWx3YXlzYCByZXBvcnRzIHRoaW5ncyBsaWtlCiIw
LjctMS1nNTc0YWI5OC1kaXJ0eSIgdG8gaW5kaWNhdGUgdGhhdCB0aGUgY2hl
Y2tvdXQgaXMgb25lIHJldmlzaW9uIHBhc3QgdGhlCjAuNyB0YWcsIGhhcyBh
IHVuaXF1ZSByZXZpc2lvbiBpZCBvZiAiNTc0YWI5OCIsIGFuZCBpcyAiZGly
dHkiIChpdCBoYXMKdW5jb21taXR0ZWQgY2hhbmdlcy4KClRoZSB2ZXJzaW9u
IGlkZW50aWZpZXIgaXMgdXNlZCBmb3IgbXVsdGlwbGUgcHVycG9zZXM6Cgoq
IHRvIGFsbG93IHRoZSBtb2R1bGUgdG8gc2VsZi1pZGVudGlmeSBpdHMgdmVy
c2lvbjogYG15cHJvamVjdC5fX3ZlcnNpb25fX2AKKiB0byBjaG9vc2UgYSBu
YW1lIGFuZCBwcmVmaXggZm9yIGEgJ3NldHVwLnB5IHNkaXN0JyB0YXJiYWxs
CgojIyBUaGVvcnkgb2YgT3BlcmF0aW9uCgpWZXJzaW9uZWVyIHdvcmtzIGJ5
IGFkZGluZyBhIHNwZWNpYWwgYF92ZXJzaW9uLnB5YCBmaWxlIGludG8geW91
ciBzb3VyY2UKdHJlZSwgd2hlcmUgeW91ciBgX19pbml0X18ucHlgIGNhbiBp
bXBvcnQgaXQuIFRoaXMgYF92ZXJzaW9uLnB5YCBrbm93cyBob3cgdG8KZHlu
YW1pY2FsbHkgYXNrIHRoZSBWQ1MgdG9vbCBmb3IgdmVyc2lvbiBpbmZvcm1h
dGlvbiBhdCBpbXBvcnQgdGltZS4KCmBfdmVyc2lvbi5weWAgYWxzbyBjb250
YWlucyBgJFJldmlzaW9uJGAgbWFya2VycywgYW5kIHRoZSBpbnN0YWxsYXRp
b24KcHJvY2VzcyBtYXJrcyBgX3ZlcnNpb24ucHlgIHRvIGhhdmUgdGhpcyBt
YXJrZXIgcmV3cml0dGVuIHdpdGggYSB0YWcgbmFtZQpkdXJpbmcgdGhlIGBn
aXQgYXJjaGl2ZWAgY29tbWFuZC4gQXMgYSByZXN1bHQsIGdlbmVyYXRlZCB0
YXJiYWxscyB3aWxsCmNvbnRhaW4gZW5vdWdoIGluZm9ybWF0aW9uIHRvIGdl
dCB0aGUgcHJvcGVyIHZlcnNpb24uCgpUbyBhbGxvdyBgc2V0dXAucHlgIHRv
IGNvbXB1dGUgYSB2ZXJzaW9uIHRvbywgYSBgdmVyc2lvbmVlci5weWAgaXMg
YWRkZWQgdG8KdGhlIHRvcCBsZXZlbCBvZiB5b3VyIHNvdXJjZSB0cmVlLCBu
ZXh0IHRvIGBzZXR1cC5weWAgYW5kIHRoZSBgc2V0dXAuY2ZnYAp0aGF0IGNv
bmZpZ3VyZXMgaXQuIFRoaXMgb3ZlcnJpZGVzIHNldmVyYWwgZGlzdHV0aWxz
L3NldHVwdG9vbHMgY29tbWFuZHMgdG8KY29tcHV0ZSB0aGUgdmVyc2lvbiB3
aGVuIGludm9rZWQsIGFuZCBjaGFuZ2VzIGBzZXR1cC5weSBidWlsZGAgYW5k
IGBzZXR1cC5weQpzZGlzdGAgdG8gcmVwbGFjZSBgX3ZlcnNpb24ucHlgIHdp
dGggYSBzbWFsbCBzdGF0aWMgZmlsZSB0aGF0IGNvbnRhaW5zIGp1c3QKdGhl
IGdlbmVyYXRlZCB2ZXJzaW9uIGRhdGEuCgojIyBJbnN0YWxsYXRpb24KClNl
ZSBbSU5TVEFMTC5tZF0oLi9JTlNUQUxMLm1kKSBmb3IgZGV0YWlsZWQgaW5z
dGFsbGF0aW9uIGluc3RydWN0aW9ucy4KCiMjIFZlcnNpb24tU3RyaW5nIEZs
YXZvcnMKCkNvZGUgd2hpY2ggdXNlcyBWZXJzaW9uZWVyIGNhbiBsZWFybiBh
Ym91dCBpdHMgdmVyc2lvbiBzdHJpbmcgYXQgcnVudGltZSBieQppbXBvcnRp
bmcgYF92ZXJzaW9uYCBmcm9tIHlvdXIgbWFpbiBgX19pbml0X18ucHlgIGZp
bGUgYW5kIHJ1bm5pbmcgdGhlCmBnZXRfdmVyc2lvbnMoKWAgZnVuY3Rpb24u
IEZyb20gdGhlICJvdXRzaWRlIiAoZS5nLiBpbiBgc2V0dXAucHlgKSwgeW91
IGNhbgppbXBvcnQgdGhlIHRvcC1sZXZlbCBgdmVyc2lvbmVlci5weWAgYW5k
IHJ1biBgZ2V0X3ZlcnNpb25zKClgLgoKQm90aCBmdW5jdGlvbnMgcmV0dXJu
IGEgZGljdGlvbmFyeSB3aXRoIGRpZmZlcmVudCBmbGF2b3JzIG9mIHZlcnNp
b24KaW5mb3JtYXRpb246CgoqIGBbJ3ZlcnNpb24nXWA6IEEgY29uZGVuc2Vk
IHZlcnNpb24gc3RyaW5nLCByZW5kZXJlZCB1c2luZyB0aGUgc2VsZWN0ZWQK
ICBzdHlsZS4gVGhpcyBpcyB0aGUgbW9zdCBjb21tb25seSB1c2VkIHZhbHVl
IGZvciB0aGUgcHJvamVjdCdzIHZlcnNpb24KICBzdHJpbmcuIFRoZSBkZWZh
dWx0ICJwZXA0NDAiIHN0eWxlIHlpZWxkcyBzdHJpbmdzIGxpa2UgYDAuMTFg
LAogIGAwLjExKzIuZzEwNzZjOTdgLCBvciBgMC4xMSsyLmcxMDc2Yzk3LmRp
cnR5YC4gU2VlIHRoZSAiU3R5bGVzIiBzZWN0aW9uCiAgYmVsb3cgZm9yIGFs
dGVybmF0aXZlIHN0eWxlcy4KCiogYFsnZnVsbC1yZXZpc2lvbmlkJ11gOiBk
ZXRhaWxlZCByZXZpc2lvbiBpZGVudGlmaWVyLiBGb3IgR2l0LCB0aGlzIGlz
IHRoZQogIGZ1bGwgU0hBMSBjb21taXQgaWQsIGUuZy4gIjEwNzZjOTc4YThk
M2NmYzcwZjQwOGZlNTk3NGFhNmMwOTJjOTQ5YWMiLgoKKiBgWydkYXRlJ11g
OiBEYXRlIGFuZCB0aW1lIG9mIHRoZSBsYXRlc3QgYEhFQURgIGNvbW1pdC4g
Rm9yIEdpdCwgaXQgaXMgdGhlCiAgY29tbWl0IGRhdGUgaW4gSVNPIDg2MDEg
Zm9ybWF0LiBUaGlzIHdpbGwgYmUgTm9uZSBpZiB0aGUgZGF0ZSBpcyBub3QK
ICBhdmFpbGFibGUuCgoqIGBbJ2RpcnR5J11gOiBhIGJvb2xlYW4sIFRydWUg
aWYgdGhlIHRyZWUgaGFzIHVuY29tbWl0dGVkIGNoYW5nZXMuIE5vdGUgdGhh
dAogIHRoaXMgaXMgb25seSBhY2N1cmF0ZSBpZiBydW4gaW4gYSBWQ1MgY2hl
Y2tvdXQsIG90aGVyd2lzZSBpdCBpcyBsaWtlbHkgdG8KICBiZSBGYWxzZSBv
ciBOb25lCgoqIGBbJ2Vycm9yJ11gOiBpZiB0aGUgdmVyc2lvbiBzdHJpbmcg
Y291bGQgbm90IGJlIGNvbXB1dGVkLCB0aGlzIHdpbGwgYmUgc2V0CiAgdG8g
YSBzdHJpbmcgZGVzY3JpYmluZyB0aGUgcHJvYmxlbSwgb3RoZXJ3aXNlIGl0
IHdpbGwgYmUgTm9uZS4gSXQgbWF5IGJlCiAgdXNlZnVsIHRvIHRocm93IGFu
IGV4Y2VwdGlvbiBpbiBzZXR1cC5weSBpZiB0aGlzIGlzIHNldCwgdG8gYXZv
aWQgZS5nLgogIGNyZWF0aW5nIHRhcmJhbGxzIHdpdGggYSB2ZXJzaW9uIHN0
cmluZyBvZiAidW5rbm93biIuCgpTb21lIHZhcmlhbnRzIGFyZSBtb3JlIHVz
ZWZ1bCB0aGFuIG90aGVycy4gSW5jbHVkaW5nIGBmdWxsLXJldmlzaW9uaWRg
IGluIGEKYnVnIHJlcG9ydCBzaG91bGQgYWxsb3cgZGV2ZWxvcGVycyB0byBy
ZWNvbnN0cnVjdCB0aGUgZXhhY3QgY29kZSBiZWluZyB0ZXN0ZWQKKG9yIGlu
ZGljYXRlIHRoZSBwcmVzZW5jZSBvZiBsb2NhbCBjaGFuZ2VzIHRoYXQgc2hv
dWxkIGJlIHNoYXJlZCB3aXRoIHRoZQpkZXZlbG9wZXJzKS4gYHZlcnNpb25g
IGlzIHN1aXRhYmxlIGZvciBkaXNwbGF5IGluIGFuICJhYm91dCIgYm94IG9y
IGEgQ0xJCmAtLXZlcnNpb25gIG91dHB1dDogaXQgY2FuIGJlIGVhc2lseSBj
b21wYXJlZCBhZ2FpbnN0IHJlbGVhc2Ugbm90ZXMgYW5kIGxpc3RzCm9mIGJ1
Z3MgZml4ZWQgaW4gdmFyaW91cyByZWxlYXNlcy4KClRoZSBpbnN0YWxsZXIg
YWRkcyB0aGUgZm9sbG93aW5nIHRleHQgdG8geW91ciBgX19pbml0X18ucHlg
IHRvIHBsYWNlIGEgYmFzaWMKdmVyc2lvbiBpbiBgWU9VUlBST0pFQ1QuX192
ZXJzaW9uX19gOgoKICAgIGZyb20gLl92ZXJzaW9uIGltcG9ydCBnZXRfdmVy
c2lvbnMKICAgIF9fdmVyc2lvbl9fID0gZ2V0X3ZlcnNpb25zKClbJ3ZlcnNp
b24nXQogICAgZGVsIGdldF92ZXJzaW9ucwoKIyMgU3R5bGVzCgpUaGUgc2V0
dXAuY2ZnIGBzdHlsZT1gIGNvbmZpZ3VyYXRpb24gY29udHJvbHMgaG93IHRo
ZSBWQ1MgaW5mb3JtYXRpb24gaXMKcmVuZGVyZWQgaW50byBhIHZlcnNpb24g
c3RyaW5nLgoKVGhlIGRlZmF1bHQgc3R5bGUsICJwZXA0NDAiLCBwcm9kdWNl
cyBhIFBFUDQ0MC1jb21wbGlhbnQgc3RyaW5nLCBlcXVhbCB0byB0aGUKdW4t
cHJlZml4ZWQgdGFnIG5hbWUgZm9yIGFjdHVhbCByZWxlYXNlcywgYW5kIGNv
bnRhaW5pbmcgYW4gYWRkaXRpb25hbCAibG9jYWwKdmVyc2lvbiIgc2VjdGlv
biB3aXRoIG1vcmUgZGV0YWlsIGZvciBpbi1iZXR3ZWVuIGJ1aWxkcy4gRm9y
IEdpdCwgdGhpcyBpcwpUQUdbK0RJU1RBTkNFLmdIRVhbLmRpcnR5XV0gLCB1
c2luZyBpbmZvcm1hdGlvbiBmcm9tIGBnaXQgZGVzY3JpYmUgLS10YWdzCi0t
ZGlydHkgLS1hbHdheXNgLiBGb3IgZXhhbXBsZSAiMC4xMSsyLmcxMDc2Yzk3
LmRpcnR5IiBpbmRpY2F0ZXMgdGhhdCB0aGUKdHJlZSBpcyBsaWtlIHRoZSAi
MTA3NmM5NyIgY29tbWl0IGJ1dCBoYXMgdW5jb21taXR0ZWQgY2hhbmdlcyAo
Ii5kaXJ0eSIpLCBhbmQKdGhhdCB0aGlzIGNvbW1pdCBpcyB0d28gcmV2aXNp
b25zICgiKzIiKSBiZXlvbmQgdGhlICIwLjExIiB0YWcuIEZvciByZWxlYXNl
ZApzb2Z0d2FyZSAoZXhhY3RseSBlcXVhbCB0byBhIGtub3duIHRhZyksIHRo
ZSBpZGVudGlmaWVyIHdpbGwgb25seSBjb250YWluIHRoZQpzdHJpcHBlZCB0
YWcsIGUuZy4gIjAuMTEiLgoKT3RoZXIgc3R5bGVzIGFyZSBhdmFpbGFibGUu
IFNlZSBbZGV0YWlscy5tZF0oZGV0YWlscy5tZCkgaW4gdGhlIFZlcnNpb25l
ZXIKc291cmNlIHRyZWUgZm9yIGRlc2NyaXB0aW9ucy4KCiMjIERlYnVnZ2lu
ZwoKVmVyc2lvbmVlciB0cmllcyB0byBhdm9pZCBmYXRhbCBlcnJvcnM6IGlm
IHNvbWV0aGluZyBnb2VzIHdyb25nLCBpdCB3aWxsIHRlbmQKdG8gcmV0dXJu
IGEgdmVyc2lvbiBvZiAiMCt1bmtub3duIi4gVG8gaW52ZXN0aWdhdGUgdGhl
IHByb2JsZW0sIHJ1biBgc2V0dXAucHkKdmVyc2lvbmAsIHdoaWNoIHdpbGwg
cnVuIHRoZSB2ZXJzaW9uLWxvb2t1cCBjb2RlIGluIGEgdmVyYm9zZSBtb2Rl
LCBhbmQgd2lsbApkaXNwbGF5IHRoZSBmdWxsIGNvbnRlbnRzIG9mIGBnZXRf
dmVyc2lvbnMoKWAgKGluY2x1ZGluZyB0aGUgYGVycm9yYCBzdHJpbmcsCndo
aWNoIG1heSBoZWxwIGlkZW50aWZ5IHdoYXQgd2VudCB3cm9uZykuCgojIyBL
bm93biBMaW1pdGF0aW9ucwoKU29tZSBzaXR1YXRpb25zIGFyZSBrbm93biB0
byBjYXVzZSBwcm9ibGVtcyBmb3IgVmVyc2lvbmVlci4gVGhpcyBkZXRhaWxz
IHRoZQptb3N0IHNpZ25pZmljYW50IG9uZXMuIE1vcmUgY2FuIGJlIGZvdW5k
IG9uIEdpdGh1YgpbaXNzdWVzIHBhZ2VdKGh0dHBzOi8vZ2l0aHViLmNvbS93
YXJuZXIvcHl0aG9uLXZlcnNpb25lZXIvaXNzdWVzKS4KCiMjIyBTdWJwcm9q
ZWN0cwoKVmVyc2lvbmVlciBoYXMgbGltaXRlZCBzdXBwb3J0IGZvciBzb3Vy
Y2UgdHJlZXMgaW4gd2hpY2ggYHNldHVwLnB5YCBpcyBub3QgaW4KdGhlIHJv
b3QgZGlyZWN0b3J5IChlLmcuIGBzZXR1cC5weWAgYW5kIGAuZ2l0L2AgYXJl
ICpub3QqIHNpYmxpbmdzKS4gVGhlIGFyZQp0d28gY29tbW9uIHJlYXNvbnMg
d2h5IGBzZXR1cC5weWAgbWlnaHQgbm90IGJlIGluIHRoZSByb290OgoKKiBT
b3VyY2UgdHJlZXMgd2hpY2ggY29udGFpbiBtdWx0aXBsZSBzdWJwcm9qZWN0
cywgc3VjaCBhcwogIFtCdWlsZGJvdF0oaHR0cHM6Ly9naXRodWIuY29tL2J1
aWxkYm90L2J1aWxkYm90KSwgd2hpY2ggY29udGFpbnMgYm90aAogICJtYXN0
ZXIiIGFuZCAic2xhdmUiIHN1YnByb2plY3RzLCBlYWNoIHdpdGggdGhlaXIg
b3duIGBzZXR1cC5weWAsCiAgYHNldHVwLmNmZ2AsIGFuZCBgdG94LmluaWAu
IFByb2plY3RzIGxpa2UgdGhlc2UgcHJvZHVjZSBtdWx0aXBsZSBQeVBJCiAg
ZGlzdHJpYnV0aW9ucyAoYW5kIHVwbG9hZCBtdWx0aXBsZSBpbmRlcGVuZGVu
dGx5LWluc3RhbGxhYmxlIHRhcmJhbGxzKS4KKiBTb3VyY2UgdHJlZXMgd2hv
c2UgbWFpbiBwdXJwb3NlIGlzIHRvIGNvbnRhaW4gYSBDIGxpYnJhcnksIGJ1
dCB3aGljaCBhbHNvCiAgcHJvdmlkZSBiaW5kaW5ncyB0byBQeXRob24gKGFu
ZCBwZXJoYXBzIG90aGVyIGxhbmdhdWdlcykgaW4gc3ViZGlyZWN0b3JpZXMu
CgpWZXJzaW9uZWVyIHdpbGwgbG9vayBmb3IgYC5naXRgIGluIHBhcmVudCBk
aXJlY3RvcmllcywgYW5kIG1vc3Qgb3BlcmF0aW9ucwpzaG91bGQgZ2V0IHRo
ZSByaWdodCB2ZXJzaW9uIHN0cmluZy4gSG93ZXZlciBgcGlwYCBhbmQgYHNl
dHVwdG9vbHNgIGhhdmUgYnVncwphbmQgaW1wbGVtZW50YXRpb24gZGV0YWls
cyB3aGljaCBmcmVxdWVudGx5IGNhdXNlIGBwaXAgaW5zdGFsbCAuYCBmcm9t
IGEKc3VicHJvamVjdCBkaXJlY3RvcnkgdG8gZmFpbCB0byBmaW5kIGEgY29y
cmVjdCB2ZXJzaW9uIHN0cmluZyAoc28gaXQgdXN1YWxseQpkZWZhdWx0cyB0
byBgMCt1bmtub3duYCkuCgpgcGlwIGluc3RhbGwgLS1lZGl0YWJsZSAuYCBz
aG91bGQgd29yayBjb3JyZWN0bHkuIGBzZXR1cC5weSBpbnN0YWxsYCBtaWdo
dAp3b3JrIHRvby4KClBpcC04LjEuMSBpcyBrbm93biB0byBoYXZlIHRoaXMg
cHJvYmxlbSwgYnV0IGhvcGVmdWxseSBpdCB3aWxsIGdldCBmaXhlZCBpbgpz
b21lIGxhdGVyIHZlcnNpb24uCgpbQnVnICMzOF0oaHR0cHM6Ly9naXRodWIu
Y29tL3dhcm5lci9weXRob24tdmVyc2lvbmVlci9pc3N1ZXMvMzgpIGlzIHRy
YWNraW5nCnRoaXMgaXNzdWUuIFRoZSBkaXNjdXNzaW9uIGluCltQUiAjNjFd
KGh0dHBzOi8vZ2l0aHViLmNvbS93YXJuZXIvcHl0aG9uLXZlcnNpb25lZXIv
cHVsbC82MSkgZGVzY3JpYmVzIHRoZQppc3N1ZSBmcm9tIHRoZSBWZXJzaW9u
ZWVyIHNpZGUgaW4gbW9yZSBkZXRhaWwuCltwaXAgUFIjMzE3Nl0oaHR0cHM6
Ly9naXRodWIuY29tL3B5cGEvcGlwL3B1bGwvMzE3NikgYW5kCltwaXAgUFIj
MzYxNV0oaHR0cHM6Ly9naXRodWIuY29tL3B5cGEvcGlwL3B1bGwvMzYxNSkg
Y29udGFpbiB3b3JrIHRvIGltcHJvdmUKcGlwIHRvIGxldCBWZXJzaW9uZWVy
IHdvcmsgY29ycmVjdGx5LgoKVmVyc2lvbmVlci0wLjE2IGFuZCBlYXJsaWVy
IG9ubHkgbG9va2VkIGZvciBhIGAuZ2l0YCBkaXJlY3RvcnkgbmV4dCB0byB0
aGUKYHNldHVwLmNmZ2AsIHNvIHN1YnByb2plY3RzIHdlcmUgY29tcGxldGVs
eSB1bnN1cHBvcnRlZCB3aXRoIHRob3NlIHJlbGVhc2VzLgoKIyMjIEVkaXRh
YmxlIGluc3RhbGxzIHdpdGggc2V0dXB0b29scyA8PSAxOC41Cgpgc2V0dXAu
cHkgZGV2ZWxvcGAgYW5kIGBwaXAgaW5zdGFsbCAtLWVkaXRhYmxlIC5gIGFs
bG93IHlvdSB0byBpbnN0YWxsIGEKcHJvamVjdCBpbnRvIGEgdmlydHVhbGVu
diBvbmNlLCB0aGVuIGNvbnRpbnVlIGVkaXRpbmcgdGhlIHNvdXJjZSBjb2Rl
IChhbmQKdGVzdCkgd2l0aG91dCByZS1pbnN0YWxsaW5nIGFmdGVyIGV2ZXJ5
IGNoYW5nZS4KCiJFbnRyeS1wb2ludCBzY3JpcHRzIiAoYHNldHVwKGVudHJ5
X3BvaW50cz17ImNvbnNvbGVfc2NyaXB0cyI6IC4ufSlgKSBhcmUgYQpjb252
ZW5pZW50IHdheSB0byBzcGVjaWZ5IGV4ZWN1dGFibGUgc2NyaXB0cyB0aGF0
IHNob3VsZCBiZSBpbnN0YWxsZWQgYWxvbmcKd2l0aCB0aGUgcHl0aG9uIHBh
Y2thZ2UuCgpUaGVzZSBib3RoIHdvcmsgYXMgZXhwZWN0ZWQgd2hlbiB1c2lu
ZyBtb2Rlcm4gc2V0dXB0b29scy4gV2hlbiB1c2luZwpzZXR1cHRvb2xzLTE4
LjUgb3IgZWFybGllciwgaG93ZXZlciwgY2VydGFpbiBvcGVyYXRpb25zIHdp
bGwgY2F1c2UKYHBrZ19yZXNvdXJjZXMuRGlzdHJpYnV0aW9uTm90Rm91bmRg
IGVycm9ycyB3aGVuIHJ1bm5pbmcgdGhlIGVudHJ5cG9pbnQKc2NyaXB0LCB3
aGljaCBtdXN0IGJlIHJlc29sdmVkIGJ5IHJlLWluc3RhbGxpbmcgdGhlIHBh
Y2thZ2UuIFRoaXMgaGFwcGVucwp3aGVuIHRoZSBpbnN0YWxsIGhhcHBlbnMg
d2l0aCBvbmUgdmVyc2lvbiwgdGhlbiB0aGUgZWdnX2luZm8gZGF0YSBpcwpy
ZWdlbmVyYXRlZCB3aGlsZSBhIGRpZmZlcmVudCB2ZXJzaW9uIGlzIGNoZWNr
ZWQgb3V0LiBNYW55IHNldHVwLnB5IGNvbW1hbmRzCmNhdXNlIGVnZ19pbmZv
IHRvIGJlIHJlYnVpbHQgKGluY2x1ZGluZyBgc2Rpc3RgLCBgd2hlZWxgLCBh
bmQgaW5zdGFsbGluZyBpbnRvCmEgZGlmZmVyZW50IHZpcnR1YWxlbnYpLCBz
byB0aGlzIGNhbiBiZSBzdXJwcmlzaW5nLgoKW0J1ZyAjODNdKGh0dHBzOi8v
Z2l0aHViLmNvbS93YXJuZXIvcHl0aG9uLXZlcnNpb25lZXIvaXNzdWVzLzgz
KSBkZXNjcmliZXMKdGhpcyBvbmUsIGJ1dCB1cGdyYWRpbmcgdG8gYSBuZXdl
ciB2ZXJzaW9uIG9mIHNldHVwdG9vbHMgc2hvdWxkIHByb2JhYmx5CnJlc29s
dmUgaXQuCgojIyMgVW5pY29kZSB2ZXJzaW9uIHN0cmluZ3MKCldoaWxlIFZl
cnNpb25lZXIgd29ya3MgKGFuZCBpcyBjb250aW51YWxseSB0ZXN0ZWQpIHdp
dGggYm90aCBQeXRob24gMiBhbmQKUHl0aG9uIDMsIGl0IGlzIG5vdCBlbnRp
cmVseSBjb25zaXN0ZW50IHdpdGggYnl0ZXMtdnMtdW5pY29kZSBkaXN0aW5j
dGlvbnMuCk5ld2VyIHJlbGVhc2VzIHByb2JhYmx5IGdlbmVyYXRlIHVuaWNv
ZGUgdmVyc2lvbiBzdHJpbmdzIG9uIHB5Mi4gSXQncyBub3QKY2xlYXIgdGhh
dCB0aGlzIGlzIHdyb25nLCBidXQgaXQgbWF5IGJlIHN1cnByaXNpbmcgZm9y
IGFwcGxpY2F0aW9ucyB3aGVuIHRoZW4Kd3JpdGUgdGhlc2Ugc3RyaW5ncyB0
byBhIG5ldHdvcmsgY29ubmVjdGlvbiBvciBpbmNsdWRlIHRoZW0gaW4gYnl0
ZXMtb3JpZW50ZWQKQVBJcyBsaWtlIGNyeXB0b2dyYXBoaWMgY2hlY2tzdW1z
LgoKW0J1ZyAjNzFdKGh0dHBzOi8vZ2l0aHViLmNvbS93YXJuZXIvcHl0aG9u
LXZlcnNpb25lZXIvaXNzdWVzLzcxKSBpbnZlc3RpZ2F0ZXMKdGhpcyBxdWVz
dGlvbi4KCgojIyBVcGRhdGluZyBWZXJzaW9uZWVyCgpUbyB1cGdyYWRlIHlv
dXIgcHJvamVjdCB0byBhIG5ldyByZWxlYXNlIG9mIFZlcnNpb25lZXIsIGRv
IHRoZSBmb2xsb3dpbmc6CgoqIGluc3RhbGwgdGhlIG5ldyBWZXJzaW9uZWVy
IChgcGlwIGluc3RhbGwgLVUgdmVyc2lvbmVlcmAgb3IgZXF1aXZhbGVudCkK
KiBlZGl0IGBzZXR1cC5jZmdgLCBpZiBuZWNlc3NhcnksIHRvIGluY2x1ZGUg
YW55IG5ldyBjb25maWd1cmF0aW9uIHNldHRpbmdzCiAgaW5kaWNhdGVkIGJ5
IHRoZSByZWxlYXNlIG5vdGVzLiBTZWUgW1VQR1JBRElOR10oLi9VUEdSQURJ
TkcubWQpIGZvciBkZXRhaWxzLgoqIHJlLXJ1biBgdmVyc2lvbmVlciBpbnN0
YWxsYCBpbiB5b3VyIHNvdXJjZSB0cmVlLCB0byByZXBsYWNlCiAgYFNSQy9f
dmVyc2lvbi5weWAKKiBjb21taXQgYW55IGNoYW5nZWQgZmlsZXMKCiMjIEZ1
dHVyZSBEaXJlY3Rpb25zCgpUaGlzIHRvb2wgaXMgZGVzaWduZWQgdG8gbWFr
ZSBpdCBlYXNpbHkgZXh0ZW5kZWQgdG8gb3RoZXIgdmVyc2lvbi1jb250cm9s
CnN5c3RlbXM6IGFsbCBWQ1Mtc3BlY2lmaWMgY29tcG9uZW50cyBhcmUgaW4g
c2VwYXJhdGUgZGlyZWN0b3JpZXMgbGlrZQpzcmMvZ2l0LyAuIFRoZSB0b3At
bGV2ZWwgYHZlcnNpb25lZXIucHlgIHNjcmlwdCBpcyBhc3NlbWJsZWQgZnJv
bSB0aGVzZQpjb21wb25lbnRzIGJ5IHJ1bm5pbmcgbWFrZS12ZXJzaW9uZWVy
LnB5IC4gSW4gdGhlIGZ1dHVyZSwgbWFrZS12ZXJzaW9uZWVyLnB5CndpbGwg
dGFrZSBhIFZDUyBuYW1lIGFzIGFuIGFyZ3VtZW50LCBhbmQgd2lsbCBjb25z
dHJ1Y3QgYSB2ZXJzaW9uIG9mCmB2ZXJzaW9uZWVyLnB5YCB0aGF0IGlzIHNw
ZWNpZmljIHRvIHRoZSBnaXZlbiBWQ1MuIEl0IG1pZ2h0IGFsc28gdGFrZSB0
aGUKY29uZmlndXJhdGlvbiBhcmd1bWVudHMgdGhhdCBhcmUgY3VycmVudGx5
IHByb3ZpZGVkIG1hbnVhbGx5IGR1cmluZwppbnN0YWxsYXRpb24gYnkgZWRp
dGluZyBzZXR1cC5weSAuIEFsdGVybmF0aXZlbHksIGl0IG1pZ2h0IGdvIHRo
ZSBvdGhlcgpkaXJlY3Rpb24gYW5kIGluY2x1ZGUgY29kZSBmcm9tIGFsbCBz
dXBwb3J0ZWQgVkNTIHN5c3RlbXMsIHJlZHVjaW5nIHRoZQpudW1iZXIgb2Yg
aW50ZXJtZWRpYXRlIHNjcmlwdHMuCgoKIyMgTGljZW5zZQoKVG8gbWFrZSBW
ZXJzaW9uZWVyIGVhc2llciB0byBlbWJlZCwgYWxsIGl0cyBjb2RlIGlzIGRl
ZGljYXRlZCB0byB0aGUgcHVibGljCmRvbWFpbi4gVGhlIGBfdmVyc2lvbi5w
eWAgdGhhdCBpdCBjcmVhdGVzIGlzIGFsc28gaW4gdGhlIHB1YmxpYyBkb21h
aW4uClNwZWNpZmljYWxseSwgYm90aCBhcmUgcmVsZWFzZWQgdW5kZXIgdGhl
IENyZWF0aXZlIENvbW1vbnMgIlB1YmxpYyBEb21haW4KRGVkaWNhdGlvbiIg
bGljZW5zZSAoQ0MwLTEuMCksIGFzIGRlc2NyaWJlZCBpbgpodHRwczovL2Ny
ZWF0aXZlY29tbW9ucy5vcmcvcHVibGljZG9tYWluL3plcm8vMS4wLyAuCj09
PT09PT0KCltweXBpLWltYWdlXTogaHR0cHM6Ly9pbWcuc2hpZWxkcy5pby9w
eXBpL3YvZmRucy12ZXJzaW9uZWVyLnN2ZwpbcHlwaS11cmxdOiBodHRwczov
L3B5cGkucHl0aG9uLm9yZy9weXBpL2ZkbnMtdmVyc2lvbmVlci8KCiIiIgoK
ZnJvbSBfX2Z1dHVyZV9fIGltcG9ydCBwcmludF9mdW5jdGlvbgp0cnk6CiAg
ICBpbXBvcnQgY29uZmlncGFyc2VyCmV4Y2VwdCBJbXBvcnRFcnJvcjoKICAg
IGltcG9ydCBDb25maWdQYXJzZXIgYXMgY29uZmlncGFyc2VyCmltcG9ydCBl
cnJubwppbXBvcnQganNvbgppbXBvcnQgb3MKaW1wb3J0IHJlCmltcG9ydCBz
dWJwcm9jZXNzCmltcG9ydCBzeXMKCgpjbGFzcyBWZXJzaW9uZWVyQ29uZmln
OgogICAgIiIiQ29udGFpbmVyIGZvciBWZXJzaW9uZWVyIGNvbmZpZ3VyYXRp
b24gcGFyYW1ldGVycy4iIiIKCgpkZWYgZ2V0X3Jvb3QoKToKICAgICIiIkdl
dCB0aGUgcHJvamVjdCByb290IGRpcmVjdG9yeS4KCiAgICBXZSByZXF1aXJl
IHRoYXQgYWxsIGNvbW1hbmRzIGFyZSBydW4gZnJvbSB0aGUgcHJvamVjdCBy
b290LCBpLmUuIHRoZQogICAgZGlyZWN0b3J5IHRoYXQgY29udGFpbnMgc2V0
dXAucHksIHNldHVwLmNmZywgYW5kIHZlcnNpb25lZXIucHkgLgogICAgIiIi
CiAgICByb290ID0gb3MucGF0aC5yZWFscGF0aChvcy5wYXRoLmFic3BhdGgo
b3MuZ2V0Y3dkKCkpKQogICAgc2V0dXBfcHkgPSBvcy5wYXRoLmpvaW4ocm9v
dCwgInNldHVwLnB5IikKICAgIHZlcnNpb25lZXJfcHkgPSBvcy5wYXRoLmpv
aW4ocm9vdCwgInZlcnNpb25lZXIucHkiKQogICAgaWYgbm90IChvcy5wYXRo
LmV4aXN0cyhzZXR1cF9weSkgb3Igb3MucGF0aC5leGlzdHModmVyc2lvbmVl
cl9weSkpOgogICAgICAgICMgYWxsb3cgJ3B5dGhvbiBwYXRoL3RvL3NldHVw
LnB5IENPTU1BTkQnCiAgICAgICAgcm9vdCA9IG9zLnBhdGguZGlybmFtZShv
cy5wYXRoLnJlYWxwYXRoKG9zLnBhdGguYWJzcGF0aChzeXMuYXJndlswXSkp
KQogICAgICAgIHNldHVwX3B5ID0gb3MucGF0aC5qb2luKHJvb3QsICJzZXR1
cC5weSIpCiAgICAgICAgdmVyc2lvbmVlcl9weSA9IG9zLnBhdGguam9pbihy
b290LCAidmVyc2lvbmVlci5weSIpCiAgICBpZiBub3QgKG9zLnBhdGguZXhp
c3RzKHNldHVwX3B5KSBvciBvcy5wYXRoLmV4aXN0cyh2ZXJzaW9uZWVyX3B5
KSk6CiAgICAgICAgZXJyID0gKCJWZXJzaW9uZWVyIHdhcyB1bmFibGUgdG8g
cnVuIHRoZSBwcm9qZWN0IHJvb3QgZGlyZWN0b3J5LiAiCiAgICAgICAgICAg
ICAgICJWZXJzaW9uZWVyIHJlcXVpcmVzIHNldHVwLnB5IHRvIGJlIGV4ZWN1
dGVkIGZyb20gIgogICAgICAgICAgICAgICAiaXRzIGltbWVkaWF0ZSBkaXJl
Y3RvcnkgKGxpa2UgJ3B5dGhvbiBzZXR1cC5weSBDT01NQU5EJyksICIKICAg
ICAgICAgICAgICAgIm9yIGluIGEgd2F5IHRoYXQgbGV0cyBpdCB1c2Ugc3lz
LmFyZ3ZbMF0gdG8gZmluZCB0aGUgcm9vdCAiCiAgICAgICAgICAgICAgICIo
bGlrZSAncHl0aG9uIHBhdGgvdG8vc2V0dXAucHkgQ09NTUFORCcpLiIpCiAg
ICAgICAgcmFpc2UgVmVyc2lvbmVlckJhZFJvb3RFcnJvcihlcnIpCiAgICB0
cnk6CiAgICAgICAgIyBDZXJ0YWluIHJ1bnRpbWUgd29ya2Zsb3dzIChzZXR1
cC5weSBpbnN0YWxsL2RldmVsb3AgaW4gYSBzZXR1cHRvb2xzCiAgICAgICAg
IyB0cmVlKSBleGVjdXRlIGFsbCBkZXBlbmRlbmNpZXMgaW4gYSBzaW5nbGUg
cHl0aG9uIHByb2Nlc3MsIHNvCiAgICAgICAgIyAidmVyc2lvbmVlciIgbWF5
IGJlIGltcG9ydGVkIG11bHRpcGxlIHRpbWVzLCBhbmQgcHl0aG9uJ3Mgc2hh
cmVkCiAgICAgICAgIyBtb2R1bGUtaW1wb3J0IHRhYmxlIHdpbGwgY2FjaGUg
dGhlIGZpcnN0IG9uZS4gU28gd2UgY2FuJ3QgdXNlCiAgICAgICAgIyBvcy5w
YXRoLmRpcm5hbWUoX19maWxlX18pLCBhcyB0aGF0IHdpbGwgZmluZCB3aGlj
aGV2ZXIKICAgICAgICAjIHZlcnNpb25lZXIucHkgd2FzIGZpcnN0IGltcG9y
dGVkLCBldmVuIGluIGxhdGVyIHByb2plY3RzLgogICAgICAgIG1lID0gb3Mu
cGF0aC5yZWFscGF0aChvcy5wYXRoLmFic3BhdGgoX19maWxlX18pKQogICAg
ICAgIG1lX2RpciA9IG9zLnBhdGgubm9ybWNhc2Uob3MucGF0aC5zcGxpdGV4
dChtZSlbMF0pCiAgICAgICAgdnNyX2RpciA9IG9zLnBhdGgubm9ybWNhc2Uo
b3MucGF0aC5zcGxpdGV4dCh2ZXJzaW9uZWVyX3B5KVswXSkKICAgICAgICBp
ZiBtZV9kaXIgIT0gdnNyX2RpcjoKICAgICAgICAgICAgcHJpbnQoIldhcm5p
bmc6IGJ1aWxkIGluICVzIGlzIHVzaW5nIHZlcnNpb25lZXIucHkgZnJvbSAl
cyIKICAgICAgICAgICAgICAgICAgJSAob3MucGF0aC5kaXJuYW1lKG1lKSwg
dmVyc2lvbmVlcl9weSkpCiAgICBleGNlcHQgTmFtZUVycm9yOgogICAgICAg
IHBhc3MKICAgIHJldHVybiByb290CgoKZGVmIGdldF9jb25maWdfZnJvbV9y
b290KHJvb3QpOgogICAgIiIiUmVhZCB0aGUgcHJvamVjdCBzZXR1cC5jZmcg
ZmlsZSB0byBkZXRlcm1pbmUgVmVyc2lvbmVlciBjb25maWcuIiIiCiAgICAj
IFRoaXMgbWlnaHQgcmFpc2UgRW52aXJvbm1lbnRFcnJvciAoaWYgc2V0dXAu
Y2ZnIGlzIG1pc3NpbmcpLCBvcgogICAgIyBjb25maWdwYXJzZXIuTm9TZWN0
aW9uRXJyb3IgKGlmIGl0IGxhY2tzIGEgW3ZlcnNpb25lZXJdIHNlY3Rpb24p
LCBvcgogICAgIyBjb25maWdwYXJzZXIuTm9PcHRpb25FcnJvciAoaWYgaXQg
bGFja3MgIlZDUz0iKS4gU2VlIHRoZSBkb2NzdHJpbmcgYXQKICAgICMgdGhl
IHRvcCBvZiB2ZXJzaW9uZWVyLnB5IGZvciBpbnN0cnVjdGlvbnMgb24gd3Jp
dGluZyB5b3VyIHNldHVwLmNmZyAuCiAgICBzZXR1cF9jZmcgPSBvcy5wYXRo
LmpvaW4ocm9vdCwgInNldHVwLmNmZyIpCiAgICBwYXJzZXIgPSBjb25maWdw
YXJzZXIuU2FmZUNvbmZpZ1BhcnNlcigpCiAgICB3aXRoIG9wZW4oc2V0dXBf
Y2ZnLCAiciIpIGFzIGY6CiAgICAgICAgcGFyc2VyLnJlYWRmcChmKQogICAg
VkNTID0gcGFyc2VyLmdldCgidmVyc2lvbmVlciIsICJWQ1MiKSAgIyBtYW5k
YXRvcnkKCiAgICBkZWYgZ2V0KHBhcnNlciwgbmFtZSk6CiAgICAgICAgaWYg
cGFyc2VyLmhhc19vcHRpb24oInZlcnNpb25lZXIiLCBuYW1lKToKICAgICAg
ICAgICAgcmV0dXJuIHBhcnNlci5nZXQoInZlcnNpb25lZXIiLCBuYW1lKQog
ICAgICAgIHJldHVybiBOb25lCiAgICBjZmcgPSBWZXJzaW9uZWVyQ29uZmln
KCkKICAgIGNmZy5WQ1MgPSBWQ1MKICAgIGNmZy5zdHlsZSA9IGdldChwYXJz
ZXIsICJzdHlsZSIpIG9yICIiCiAgICBjZmcudmVyc2lvbmZpbGVfc291cmNl
ID0gZ2V0KHBhcnNlciwgInZlcnNpb25maWxlX3NvdXJjZSIpCiAgICBjZmcu
dmVyc2lvbmZpbGVfYnVpbGQgPSBnZXQocGFyc2VyLCAidmVyc2lvbmZpbGVf
YnVpbGQiKQogICAgY2ZnLnRhZ19wcmVmaXggPSBnZXQocGFyc2VyLCAidGFn
X3ByZWZpeCIpCiAgICBpZiBjZmcudGFnX3ByZWZpeCBpbiAoIicnIiwgJyIi
Jyk6CiAgICAgICAgY2ZnLnRhZ19wcmVmaXggPSAiIgogICAgY2ZnLnBhcmVu
dGRpcl9wcmVmaXggPSBnZXQocGFyc2VyLCAicGFyZW50ZGlyX3ByZWZpeCIp
CiAgICBjZmcudmVyYm9zZSA9IGdldChwYXJzZXIsICJ2ZXJib3NlIikKICAg
IHJldHVybiBjZmcKCgpjbGFzcyBOb3RUaGlzTWV0aG9kKEV4Y2VwdGlvbik6
CiAgICAiIiJFeGNlcHRpb24gcmFpc2VkIGlmIGEgbWV0aG9kIGlzIG5vdCB2
YWxpZCBmb3IgdGhlIGN1cnJlbnQgc2NlbmFyaW8uIiIiCgoKIyB0aGVzZSBk
aWN0aW9uYXJpZXMgY29udGFpbiBWQ1Mtc3BlY2lmaWMgdG9vbHMKTE9OR19W
RVJTSU9OX1BZID0ge30KSEFORExFUlMgPSB7fQoKCmRlZiByZWdpc3Rlcl92
Y3NfaGFuZGxlcih2Y3MsIG1ldGhvZCk6ICAjIGRlY29yYXRvcgogICAgIiIi
RGVjb3JhdG9yIHRvIG1hcmsgYSBtZXRob2QgYXMgdGhlIGhhbmRsZXIgZm9y
IGEgcGFydGljdWxhciBWQ1MuIiIiCiAgICBkZWYgZGVjb3JhdGUoZik6CiAg
ICAgICAgIiIiU3RvcmUgZiBpbiBIQU5ETEVSU1t2Y3NdW21ldGhvZF0uIiIi
CiAgICAgICAgaWYgdmNzIG5vdCBpbiBIQU5ETEVSUzoKICAgICAgICAgICAg
SEFORExFUlNbdmNzXSA9IHt9CiAgICAgICAgSEFORExFUlNbdmNzXVttZXRo
b2RdID0gZgogICAgICAgIHJldHVybiBmCiAgICByZXR1cm4gZGVjb3JhdGUK
CgpkZWYgcnVuX2NvbW1hbmQoY29tbWFuZHMsIGFyZ3MsIGN3ZD1Ob25lLCB2
ZXJib3NlPUZhbHNlLCBoaWRlX3N0ZGVycj1GYWxzZSwKICAgICAgICAgICAg
ICAgIGVudj1Ob25lKToKICAgICIiIkNhbGwgdGhlIGdpdmVuIGNvbW1hbmQo
cykuIiIiCiAgICBhc3NlcnQgaXNpbnN0YW5jZShjb21tYW5kcywgbGlzdCkK
ICAgIHAgPSBOb25lCiAgICBmb3IgYyBpbiBjb21tYW5kczoKICAgICAgICB0
cnk6CiAgICAgICAgICAgIGRpc3BjbWQgPSBzdHIoW2NdICsgYXJncykKICAg
ICAgICAgICAgIyByZW1lbWJlciBzaGVsbD1GYWxzZSwgc28gdXNlIGdpdC5j
bWQgb24gd2luZG93cywgbm90IGp1c3QgZ2l0CiAgICAgICAgICAgIHAgPSBz
dWJwcm9jZXNzLlBvcGVuKFtjXSArIGFyZ3MsIGN3ZD1jd2QsIGVudj1lbnYs
CiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIHN0ZG91dD1zdWJw
cm9jZXNzLlBJUEUsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
IHN0ZGVycj0oc3VicHJvY2Vzcy5QSVBFIGlmIGhpZGVfc3RkZXJyCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgZWxzZSBOb25l
KSkKICAgICAgICAgICAgYnJlYWsKICAgICAgICBleGNlcHQgRW52aXJvbm1l
bnRFcnJvcjoKICAgICAgICAgICAgZSA9IHN5cy5leGNfaW5mbygpWzFdCiAg
ICAgICAgICAgIGlmIGUuZXJybm8gPT0gZXJybm8uRU5PRU5UOgogICAgICAg
ICAgICAgICAgY29udGludWUKICAgICAgICAgICAgaWYgdmVyYm9zZToKICAg
ICAgICAgICAgICAgIHByaW50KCJ1bmFibGUgdG8gcnVuICVzIiAlIGRpc3Bj
bWQpCiAgICAgICAgICAgICAgICBwcmludChlKQogICAgICAgICAgICByZXR1
cm4gTm9uZSwgTm9uZQogICAgZWxzZToKICAgICAgICBpZiB2ZXJib3NlOgog
ICAgICAgICAgICBwcmludCgidW5hYmxlIHRvIGZpbmQgY29tbWFuZCwgdHJp
ZWQgJXMiICUgKGNvbW1hbmRzLCkpCiAgICAgICAgcmV0dXJuIE5vbmUsIE5v
bmUKICAgIHN0ZG91dCA9IHAuY29tbXVuaWNhdGUoKVswXS5zdHJpcCgpCiAg
ICBpZiBzeXMudmVyc2lvbl9pbmZvWzBdID49IDM6CiAgICAgICAgc3Rkb3V0
ID0gc3Rkb3V0LmRlY29kZSgpCiAgICBpZiBwLnJldHVybmNvZGUgIT0gMDoK
ICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgidW5hYmxl
IHRvIHJ1biAlcyAoZXJyb3IpIiAlIGRpc3BjbWQpCiAgICAgICAgICAgIHBy
aW50KCJzdGRvdXQgd2FzICVzIiAlIHN0ZG91dCkKICAgICAgICByZXR1cm4g
Tm9uZSwgcC5yZXR1cm5jb2RlCiAgICByZXR1cm4gc3Rkb3V0LCBwLnJldHVy
bmNvZGUKCgpMT05HX1ZFUlNJT05fUFlbJ2dpdCddID0gJycnCiMgVGhpcyBm
aWxlIGhlbHBzIHRvIGNvbXB1dGUgYSB2ZXJzaW9uIG51bWJlciBpbiBzb3Vy
Y2UgdHJlZXMgb2J0YWluZWQgZnJvbQojIGdpdC1hcmNoaXZlIHRhcmJhbGwg
KHN1Y2ggYXMgdGhvc2UgcHJvdmlkZWQgYnkgZ2l0aHVicyBkb3dubG9hZC1m
cm9tLXRhZwojIGZlYXR1cmUpLiBEaXN0cmlidXRpb24gdGFyYmFsbHMgKGJ1
aWx0IGJ5IHNldHVwLnB5IHNkaXN0KSBhbmQgYnVpbGQKIyBkaXJlY3Rvcmll
cyAocHJvZHVjZWQgYnkgc2V0dXAucHkgYnVpbGQpIHdpbGwgY29udGFpbiBh
IG11Y2ggc2hvcnRlciBmaWxlCiMgdGhhdCBqdXN0IGNvbnRhaW5zIHRoZSBj
b21wdXRlZCB2ZXJzaW9uIG51bWJlci4KCiMgVGhpcyBmaWxlIGlzIHJlbGVh
c2VkIGludG8gdGhlIHB1YmxpYyBkb21haW4uIEdlbmVyYXRlZCBieQojIHZl
cnNpb25lZXItMC4xOC4xIChodHRwczovL2dpdGh1Yi5jb20vd2FybmVyL3B5
dGhvbi12ZXJzaW9uZWVyKQoKIiIiR2l0IGltcGxlbWVudGF0aW9uIG9mIF92
ZXJzaW9uLnB5LiIiIgoKaW1wb3J0IGVycm5vCmltcG9ydCBvcwppbXBvcnQg
cmUKaW1wb3J0IHN1YnByb2Nlc3MKaW1wb3J0IHN5cwoKCmRlZiBnZXRfa2V5
d29yZHMoKToKICAgICIiIkdldCB0aGUga2V5d29yZHMgbmVlZGVkIHRvIGxv
b2sgdXAgdGhlIHZlcnNpb24gaW5mb3JtYXRpb24uIiIiCiAgICAjIHRoZXNl
IHN0cmluZ3Mgd2lsbCBiZSByZXBsYWNlZCBieSBnaXQgZHVyaW5nIGdpdC1h
cmNoaXZlLgogICAgIyBzZXR1cC5weS92ZXJzaW9uZWVyLnB5IHdpbGwgZ3Jl
cCBmb3IgdGhlIHZhcmlhYmxlIG5hbWVzLCBzbyB0aGV5IG11c3QKICAgICMg
ZWFjaCBiZSBkZWZpbmVkIG9uIGEgbGluZSBvZiB0aGVpciBvd24uIF92ZXJz
aW9uLnB5IHdpbGwganVzdCBjYWxsCiAgICAjIGdldF9rZXl3b3JkcygpLgog
ICAgZ2l0X3JlZm5hbWVzID0gIiUoRE9MTEFSKXNGb3JtYXQ6JSVkJShET0xM
QVIpcyIKICAgIGdpdF9mdWxsID0gIiUoRE9MTEFSKXNGb3JtYXQ6JSVIJShE
T0xMQVIpcyIKICAgIGdpdF9kYXRlID0gIiUoRE9MTEFSKXNGb3JtYXQ6JSVj
aSUoRE9MTEFSKXMiCiAgICBrZXl3b3JkcyA9IHsicmVmbmFtZXMiOiBnaXRf
cmVmbmFtZXMsICJmdWxsIjogZ2l0X2Z1bGwsICJkYXRlIjogZ2l0X2RhdGV9
CiAgICByZXR1cm4ga2V5d29yZHMKCgpjbGFzcyBWZXJzaW9uZWVyQ29uZmln
OgogICAgIiIiQ29udGFpbmVyIGZvciBWZXJzaW9uZWVyIGNvbmZpZ3VyYXRp
b24gcGFyYW1ldGVycy4iIiIKCgpkZWYgZ2V0X2NvbmZpZygpOgogICAgIiIi
Q3JlYXRlLCBwb3B1bGF0ZSBhbmQgcmV0dXJuIHRoZSBWZXJzaW9uZWVyQ29u
ZmlnKCkgb2JqZWN0LiIiIgogICAgIyB0aGVzZSBzdHJpbmdzIGFyZSBmaWxs
ZWQgaW4gd2hlbiAnc2V0dXAucHkgdmVyc2lvbmVlcicgY3JlYXRlcwogICAg
IyBfdmVyc2lvbi5weQogICAgY2ZnID0gVmVyc2lvbmVlckNvbmZpZygpCiAg
ICBjZmcuVkNTID0gImdpdCIKICAgIGNmZy5zdHlsZSA9ICIlKFNUWUxFKXMi
CiAgICBjZmcudGFnX3ByZWZpeCA9ICIlKFRBR19QUkVGSVgpcyIKICAgIGNm
Zy5wYXJlbnRkaXJfcHJlZml4ID0gIiUoUEFSRU5URElSX1BSRUZJWClzIgog
ICAgY2ZnLnZlcnNpb25maWxlX3NvdXJjZSA9ICIlKFZFUlNJT05GSUxFX1NP
VVJDRSlzIgogICAgY2ZnLnZlcmJvc2UgPSBGYWxzZQogICAgcmV0dXJuIGNm
ZwoKCmNsYXNzIE5vdFRoaXNNZXRob2QoRXhjZXB0aW9uKToKICAgICIiIkV4
Y2VwdGlvbiByYWlzZWQgaWYgYSBtZXRob2QgaXMgbm90IHZhbGlkIGZvciB0
aGUgY3VycmVudCBzY2VuYXJpby4iIiIKCgpMT05HX1ZFUlNJT05fUFkgPSB7
fQpIQU5ETEVSUyA9IHt9CgoKZGVmIHJlZ2lzdGVyX3Zjc19oYW5kbGVyKHZj
cywgbWV0aG9kKTogICMgZGVjb3JhdG9yCiAgICAiIiJEZWNvcmF0b3IgdG8g
bWFyayBhIG1ldGhvZCBhcyB0aGUgaGFuZGxlciBmb3IgYSBwYXJ0aWN1bGFy
IFZDUy4iIiIKICAgIGRlZiBkZWNvcmF0ZShmKToKICAgICAgICAiIiJTdG9y
ZSBmIGluIEhBTkRMRVJTW3Zjc11bbWV0aG9kXS4iIiIKICAgICAgICBpZiB2
Y3Mgbm90IGluIEhBTkRMRVJTOgogICAgICAgICAgICBIQU5ETEVSU1t2Y3Nd
ID0ge30KICAgICAgICBIQU5ETEVSU1t2Y3NdW21ldGhvZF0gPSBmCiAgICAg
ICAgcmV0dXJuIGYKICAgIHJldHVybiBkZWNvcmF0ZQoKCmRlZiBydW5fY29t
bWFuZChjb21tYW5kcywgYXJncywgY3dkPU5vbmUsIHZlcmJvc2U9RmFsc2Us
IGhpZGVfc3RkZXJyPUZhbHNlLAogICAgICAgICAgICAgICAgZW52PU5vbmUp
OgogICAgIiIiQ2FsbCB0aGUgZ2l2ZW4gY29tbWFuZChzKS4iIiIKICAgIGFz
c2VydCBpc2luc3RhbmNlKGNvbW1hbmRzLCBsaXN0KQogICAgcCA9IE5vbmUK
ICAgIGZvciBjIGluIGNvbW1hbmRzOgogICAgICAgIHRyeToKICAgICAgICAg
ICAgZGlzcGNtZCA9IHN0cihbY10gKyBhcmdzKQogICAgICAgICAgICAjIHJl
bWVtYmVyIHNoZWxsPUZhbHNlLCBzbyB1c2UgZ2l0LmNtZCBvbiB3aW5kb3dz
LCBub3QganVzdCBnaXQKICAgICAgICAgICAgcCA9IHN1YnByb2Nlc3MuUG9w
ZW4oW2NdICsgYXJncywgY3dkPWN3ZCwgZW52PWVudiwKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgc3Rkb3V0PXN1YnByb2Nlc3MuUElQRSwK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgc3RkZXJyPShzdWJw
cm9jZXNzLlBJUEUgaWYgaGlkZV9zdGRlcnIKICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICBlbHNlIE5vbmUpKQogICAgICAgICAg
ICBicmVhawogICAgICAgIGV4Y2VwdCBFbnZpcm9ubWVudEVycm9yOgogICAg
ICAgICAgICBlID0gc3lzLmV4Y19pbmZvKClbMV0KICAgICAgICAgICAgaWYg
ZS5lcnJubyA9PSBlcnJuby5FTk9FTlQ6CiAgICAgICAgICAgICAgICBjb250
aW51ZQogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICAgICAg
cHJpbnQoInVuYWJsZSB0byBydW4gJSVzIiAlJSBkaXNwY21kKQogICAgICAg
ICAgICAgICAgcHJpbnQoZSkKICAgICAgICAgICAgcmV0dXJuIE5vbmUsIE5v
bmUKICAgIGVsc2U6CiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAg
cHJpbnQoInVuYWJsZSB0byBmaW5kIGNvbW1hbmQsIHRyaWVkICUlcyIgJSUg
KGNvbW1hbmRzLCkpCiAgICAgICAgcmV0dXJuIE5vbmUsIE5vbmUKICAgIHN0
ZG91dCA9IHAuY29tbXVuaWNhdGUoKVswXS5zdHJpcCgpCiAgICBpZiBzeXMu
dmVyc2lvbl9pbmZvWzBdID49IDM6CiAgICAgICAgc3Rkb3V0ID0gc3Rkb3V0
LmRlY29kZSgpCiAgICBpZiBwLnJldHVybmNvZGUgIT0gMDoKICAgICAgICBp
ZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgidW5hYmxlIHRvIHJ1biAl
JXMgKGVycm9yKSIgJSUgZGlzcGNtZCkKICAgICAgICAgICAgcHJpbnQoInN0
ZG91dCB3YXMgJSVzIiAlJSBzdGRvdXQpCiAgICAgICAgcmV0dXJuIE5vbmUs
IHAucmV0dXJuY29kZQogICAgcmV0dXJuIHN0ZG91dCwgcC5yZXR1cm5jb2Rl
CgoKZGVmIHZlcnNpb25zX2Zyb21fcGFyZW50ZGlyKHBhcmVudGRpcl9wcmVm
aXgsIHJvb3QsIHZlcmJvc2UpOgogICAgIiIiVHJ5IHRvIGRldGVybWluZSB0
aGUgdmVyc2lvbiBmcm9tIHRoZSBwYXJlbnQgZGlyZWN0b3J5IG5hbWUuCgog
ICAgU291cmNlIHRhcmJhbGxzIGNvbnZlbnRpb25hbGx5IHVucGFjayBpbnRv
IGEgZGlyZWN0b3J5IHRoYXQgaW5jbHVkZXMgYm90aAogICAgdGhlIHByb2pl
Y3QgbmFtZSBhbmQgYSB2ZXJzaW9uIHN0cmluZy4gV2Ugd2lsbCBhbHNvIHN1
cHBvcnQgc2VhcmNoaW5nIHVwCiAgICB0d28gZGlyZWN0b3J5IGxldmVscyBm
b3IgYW4gYXBwcm9wcmlhdGVseSBuYW1lZCBwYXJlbnQgZGlyZWN0b3J5CiAg
ICAiIiIKICAgIHJvb3RkaXJzID0gW10KCiAgICBmb3IgaSBpbiByYW5nZSgz
KToKICAgICAgICBkaXJuYW1lID0gb3MucGF0aC5iYXNlbmFtZShyb290KQog
ICAgICAgIGlmIGRpcm5hbWUuc3RhcnRzd2l0aChwYXJlbnRkaXJfcHJlZml4
KToKICAgICAgICAgICAgcmV0dXJuIHsidmVyc2lvbiI6IGRpcm5hbWVbbGVu
KHBhcmVudGRpcl9wcmVmaXgpOl0sCiAgICAgICAgICAgICAgICAgICAgImZ1
bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAgICAgICAgICAgICAgImRp
cnR5IjogRmFsc2UsICJlcnJvciI6IE5vbmUsICJkYXRlIjogTm9uZX0KICAg
ICAgICBlbHNlOgogICAgICAgICAgICByb290ZGlycy5hcHBlbmQocm9vdCkK
ICAgICAgICAgICAgcm9vdCA9IG9zLnBhdGguZGlybmFtZShyb290KSAgIyB1
cCBhIGxldmVsCgogICAgaWYgdmVyYm9zZToKICAgICAgICBwcmludCgiVHJp
ZWQgZGlyZWN0b3JpZXMgJSVzIGJ1dCBub25lIHN0YXJ0ZWQgd2l0aCBwcmVm
aXggJSVzIiAlJQogICAgICAgICAgICAgIChzdHIocm9vdGRpcnMpLCBwYXJl
bnRkaXJfcHJlZml4KSkKICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoInJvb3Rk
aXIgZG9lc24ndCBzdGFydCB3aXRoIHBhcmVudGRpcl9wcmVmaXgiKQoKCkBy
ZWdpc3Rlcl92Y3NfaGFuZGxlcigiZ2l0IiwgImdldF9rZXl3b3JkcyIpCmRl
ZiBnaXRfZ2V0X2tleXdvcmRzKHZlcnNpb25maWxlX2Ficyk6CiAgICAiIiJF
eHRyYWN0IHZlcnNpb24gaW5mb3JtYXRpb24gZnJvbSB0aGUgZ2l2ZW4gZmls
ZS4iIiIKICAgICMgdGhlIGNvZGUgZW1iZWRkZWQgaW4gX3ZlcnNpb24ucHkg
Y2FuIGp1c3QgZmV0Y2ggdGhlIHZhbHVlIG9mIHRoZXNlCiAgICAjIGtleXdv
cmRzLiBXaGVuIHVzZWQgZnJvbSBzZXR1cC5weSwgd2UgZG9uJ3Qgd2FudCB0
byBpbXBvcnQgX3ZlcnNpb24ucHksCiAgICAjIHNvIHdlIGRvIGl0IHdpdGgg
YSByZWdleHAgaW5zdGVhZC4gVGhpcyBmdW5jdGlvbiBpcyBub3QgdXNlZCBm
cm9tCiAgICAjIF92ZXJzaW9uLnB5LgogICAga2V5d29yZHMgPSB7fQogICAg
dHJ5OgogICAgICAgIGYgPSBvcGVuKHZlcnNpb25maWxlX2FicywgInIiKQog
ICAgICAgIGZvciBsaW5lIGluIGYucmVhZGxpbmVzKCk6CiAgICAgICAgICAg
IGlmIGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKCJnaXRfcmVmbmFtZXMgPSIp
OgogICAgICAgICAgICAgICAgbW8gPSByZS5zZWFyY2gocic9XHMqIiguKiki
JywgbGluZSkKICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAgICAg
ICAgICAgIGtleXdvcmRzWyJyZWZuYW1lcyJdID0gbW8uZ3JvdXAoMSkKICAg
ICAgICAgICAgaWYgbGluZS5zdHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9mdWxs
ID0iKToKICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxzKiIo
LiopIicsIGxpbmUpCiAgICAgICAgICAgICAgICBpZiBtbzoKICAgICAgICAg
ICAgICAgICAgICBrZXl3b3Jkc1siZnVsbCJdID0gbW8uZ3JvdXAoMSkKICAg
ICAgICAgICAgaWYgbGluZS5zdHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9kYXRl
ID0iKToKICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxzKiIo
LiopIicsIGxpbmUpCiAgICAgICAgICAgICAgICBpZiBtbzoKICAgICAgICAg
ICAgICAgICAgICBrZXl3b3Jkc1siZGF0ZSJdID0gbW8uZ3JvdXAoMSkKICAg
ICAgICBmLmNsb3NlKCkKICAgIGV4Y2VwdCBFbnZpcm9ubWVudEVycm9yOgog
ICAgICAgIHBhc3MKICAgIHJldHVybiBrZXl3b3JkcwoKCkByZWdpc3Rlcl92
Y3NfaGFuZGxlcigiZ2l0IiwgImtleXdvcmRzIikKZGVmIGdpdF92ZXJzaW9u
c19mcm9tX2tleXdvcmRzKGtleXdvcmRzLCB0YWdfcHJlZml4LCB2ZXJib3Nl
KToKICAgICIiIkdldCB2ZXJzaW9uIGluZm9ybWF0aW9uIGZyb20gZ2l0IGtl
eXdvcmRzLiIiIgogICAgaWYgbm90IGtleXdvcmRzOgogICAgICAgIHJhaXNl
IE5vdFRoaXNNZXRob2QoIm5vIGtleXdvcmRzIGF0IGFsbCwgd2VpcmQiKQog
ICAgZGF0ZSA9IGtleXdvcmRzLmdldCgiZGF0ZSIpCiAgICBpZiBkYXRlIGlz
IG5vdCBOb25lOgogICAgICAgICMgZ2l0LTIuMi4wIGFkZGVkICIlJWNJIiwg
d2hpY2ggZXhwYW5kcyB0byBhbiBJU08tODYwMSAtY29tcGxpYW50CiAgICAg
ICAgIyBkYXRlc3RhbXAuIEhvd2V2ZXIgd2UgcHJlZmVyICIlJWNpIiAod2hp
Y2ggZXhwYW5kcyB0byBhbiAiSVNPLTg2MDEKICAgICAgICAjIC1saWtlIiBz
dHJpbmcsIHdoaWNoIHdlIG11c3QgdGhlbiBlZGl0IHRvIG1ha2UgY29tcGxp
YW50KSwgYmVjYXVzZQogICAgICAgICMgaXQncyBiZWVuIGFyb3VuZCBzaW5j
ZSBnaXQtMS41LjMsIGFuZCBpdCdzIHRvbyBkaWZmaWN1bHQgdG8KICAgICAg
ICAjIGRpc2NvdmVyIHdoaWNoIHZlcnNpb24gd2UncmUgdXNpbmcsIG9yIHRv
IHdvcmsgYXJvdW5kIHVzaW5nIGFuCiAgICAgICAgIyBvbGRlciBvbmUuCiAg
ICAgICAgZGF0ZSA9IGRhdGUuc3RyaXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAx
KS5yZXBsYWNlKCIgIiwgIiIsIDEpCiAgICByZWZuYW1lcyA9IGtleXdvcmRz
WyJyZWZuYW1lcyJdLnN0cmlwKCkKICAgIGlmIHJlZm5hbWVzLnN0YXJ0c3dp
dGgoIiRGb3JtYXQiKToKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAg
ICBwcmludCgia2V5d29yZHMgYXJlIHVuZXhwYW5kZWQsIG5vdCB1c2luZyIp
CiAgICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgidW5leHBhbmRlZCBrZXl3
b3Jkcywgbm90IGEgZ2l0LWFyY2hpdmUgdGFyYmFsbCIpCiAgICByZWZzID0g
c2V0KFtyLnN0cmlwKCkgZm9yIHIgaW4gcmVmbmFtZXMuc3RyaXAoIigpIiku
c3BsaXQoIiwiKV0pCiAgICAjIHN0YXJ0aW5nIGluIGdpdC0xLjguMywgdGFn
cyBhcmUgbGlzdGVkIGFzICJ0YWc6IGZvby0xLjAiIGluc3RlYWQgb2YKICAg
ICMganVzdCAiZm9vLTEuMCIuIElmIHdlIHNlZSBhICJ0YWc6ICIgcHJlZml4
LCBwcmVmZXIgdGhvc2UuCiAgICBUQUcgPSAidGFnOiAiCiAgICB0YWdzID0g
c2V0KFtyW2xlbihUQUcpOl0gZm9yIHIgaW4gcmVmcyBpZiByLnN0YXJ0c3dp
dGgoVEFHKV0pCiAgICBpZiBub3QgdGFnczoKICAgICAgICAjIEVpdGhlciB3
ZSdyZSB1c2luZyBnaXQgPCAxLjguMywgb3IgdGhlcmUgcmVhbGx5IGFyZSBu
byB0YWdzLiBXZSB1c2UKICAgICAgICAjIGEgaGV1cmlzdGljOiBhc3N1bWUg
YWxsIHZlcnNpb24gdGFncyBoYXZlIGEgZGlnaXQuIFRoZSBvbGQgZ2l0ICUl
ZAogICAgICAgICMgZXhwYW5zaW9uIGJlaGF2ZXMgbGlrZSBnaXQgbG9nIC0t
ZGVjb3JhdGU9c2hvcnQgYW5kIHN0cmlwcyBvdXQgdGhlCiAgICAgICAgIyBy
ZWZzL2hlYWRzLyBhbmQgcmVmcy90YWdzLyBwcmVmaXhlcyB0aGF0IHdvdWxk
IGxldCB1cyBkaXN0aW5ndWlzaAogICAgICAgICMgYmV0d2VlbiBicmFuY2hl
cyBhbmQgdGFncy4gQnkgaWdub3JpbmcgcmVmbmFtZXMgd2l0aG91dCBkaWdp
dHMsIHdlCiAgICAgICAgIyBmaWx0ZXIgb3V0IG1hbnkgY29tbW9uIGJyYW5j
aCBuYW1lcyBsaWtlICJyZWxlYXNlIiBhbmQKICAgICAgICAjICJzdGFiaWxp
emF0aW9uIiwgYXMgd2VsbCBhcyAiSEVBRCIgYW5kICJtYXN0ZXIiLgogICAg
ICAgIHRhZ3MgPSBzZXQoW3IgZm9yIHIgaW4gcmVmcyBpZiByZS5zZWFyY2go
cidcZCcsIHIpXSkKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBw
cmludCgiZGlzY2FyZGluZyAnJSVzJywgbm8gZGlnaXRzIiAlJSAiLCIuam9p
bihyZWZzIC0gdGFncykpCiAgICBpZiB2ZXJib3NlOgogICAgICAgIHByaW50
KCJsaWtlbHkgdGFnczogJSVzIiAlJSAiLCIuam9pbihzb3J0ZWQodGFncykp
KQogICAgZm9yIHJlZiBpbiBzb3J0ZWQodGFncyk6CiAgICAgICAgIyBzb3J0
aW5nIHdpbGwgcHJlZmVyIGUuZy4gIjIuMCIgb3ZlciAiMi4wcmMxIgogICAg
ICAgIGlmIHJlZi5zdGFydHN3aXRoKHRhZ19wcmVmaXgpOgogICAgICAgICAg
ICByID0gcmVmW2xlbih0YWdfcHJlZml4KTpdCiAgICAgICAgICAgIGlmIHZl
cmJvc2U6CiAgICAgICAgICAgICAgICBwcmludCgicGlja2luZyAlJXMiICUl
IHIpCiAgICAgICAgICAgIHJldHVybiB7InZlcnNpb24iOiByLAogICAgICAg
ICAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQiOiBrZXl3b3Jkc1siZnVs
bCJdLnN0cmlwKCksCiAgICAgICAgICAgICAgICAgICAgImRpcnR5IjogRmFs
c2UsICJlcnJvciI6IE5vbmUsCiAgICAgICAgICAgICAgICAgICAgImRhdGUi
OiBkYXRlfQogICAgIyBubyBzdWl0YWJsZSB0YWdzLCBzbyB2ZXJzaW9uIGlz
ICIwK3Vua25vd24iLCBidXQgZnVsbCBoZXggaXMgc3RpbGwgdGhlcmUKICAg
IGlmIHZlcmJvc2U6CiAgICAgICAgcHJpbnQoIm5vIHN1aXRhYmxlIHRhZ3Ms
IHVzaW5nIHVua25vd24gKyBmdWxsIHJldmlzaW9uIGlkIikKICAgIHJldHVy
biB7InZlcnNpb24iOiAiMCt1bmtub3duIiwKICAgICAgICAgICAgImZ1bGwt
cmV2aXNpb25pZCI6IGtleXdvcmRzWyJmdWxsIl0uc3RyaXAoKSwKICAgICAg
ICAgICAgImRpcnR5IjogRmFsc2UsICJlcnJvciI6ICJubyBzdWl0YWJsZSB0
YWdzIiwgImRhdGUiOiBOb25lfQoKCkByZWdpc3Rlcl92Y3NfaGFuZGxlcigi
Z2l0IiwgInBpZWNlc19mcm9tX3ZjcyIpCmRlZiBnaXRfcGllY2VzX2Zyb21f
dmNzKHRhZ19wcmVmaXgsIHJvb3QsIHZlcmJvc2UsIHJ1bl9jb21tYW5kPXJ1
bl9jb21tYW5kKToKICAgICIiIkdldCB2ZXJzaW9uIGZyb20gJ2dpdCBkZXNj
cmliZScgaW4gdGhlIHJvb3Qgb2YgdGhlIHNvdXJjZSB0cmVlLgoKICAgIFRo
aXMgb25seSBnZXRzIGNhbGxlZCBpZiB0aGUgZ2l0LWFyY2hpdmUgJ3N1YnN0
JyBrZXl3b3JkcyB3ZXJlICpub3QqCiAgICBleHBhbmRlZCwgYW5kIF92ZXJz
aW9uLnB5IGhhc24ndCBhbHJlYWR5IGJlZW4gcmV3cml0dGVuIHdpdGggYSBz
aG9ydAogICAgdmVyc2lvbiBzdHJpbmcsIG1lYW5pbmcgd2UncmUgaW5zaWRl
IGEgY2hlY2tlZCBvdXQgc291cmNlIHRyZWUuCiAgICAiIiIKICAgIEdJVFMg
PSBbImdpdCJdCiAgICBpZiBzeXMucGxhdGZvcm0gPT0gIndpbjMyIjoKICAg
ICAgICBHSVRTID0gWyJnaXQuY21kIiwgImdpdC5leGUiXQoKICAgIG91dCwg
cmMgPSBydW5fY29tbWFuZChHSVRTLCBbInJldi1wYXJzZSIsICItLWdpdC1k
aXIiXSwgY3dkPXJvb3QsCiAgICAgICAgICAgICAgICAgICAgICAgICAgaGlk
ZV9zdGRlcnI9VHJ1ZSkKICAgIGlmIHJjICE9IDA6CiAgICAgICAgaWYgdmVy
Ym9zZToKICAgICAgICAgICAgcHJpbnQoIkRpcmVjdG9yeSAlJXMgbm90IHVu
ZGVyIGdpdCBjb250cm9sIiAlJSByb290KQogICAgICAgIHJhaXNlIE5vdFRo
aXNNZXRob2QoIidnaXQgcmV2LXBhcnNlIC0tZ2l0LWRpcicgcmV0dXJuZWQg
ZXJyb3IiKQoKICAgICMgaWYgdGhlcmUgaXMgYSB0YWcgbWF0Y2hpbmcgdGFn
X3ByZWZpeCwgdGhpcyB5aWVsZHMgVEFHLU5VTS1nSEVYWy1kaXJ0eV0KICAg
ICMgaWYgdGhlcmUgaXNuJ3Qgb25lLCB0aGlzIHlpZWxkcyBIRVhbLWRpcnR5
XSAobm8gTlVNKQogICAgZGVzY3JpYmVfb3V0LCByYyA9IHJ1bl9jb21tYW5k
KEdJVFMsIFsiZGVzY3JpYmUiLCAiLS10YWdzIiwgIi0tZGlydHkiLAogICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAiLS1hbHdh
eXMiLCAiLS1sb25nIiwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIi0tbWF0Y2giLCAiJSVzKiIgJSUgdGFnX3ByZWZpeF0s
CiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgY3dkPXJvb3Qp
CiAgICAjIC0tbG9uZyB3YXMgYWRkZWQgaW4gZ2l0LTEuNS41CiAgICBpZiBk
ZXNjcmliZV9vdXQgaXMgTm9uZToKICAgICAgICByYWlzZSBOb3RUaGlzTWV0
aG9kKCInZ2l0IGRlc2NyaWJlJyBmYWlsZWQiKQogICAgZGVzY3JpYmVfb3V0
ID0gZGVzY3JpYmVfb3V0LnN0cmlwKCkKICAgIGZ1bGxfb3V0LCByYyA9IHJ1
bl9jb21tYW5kKEdJVFMsIFsicmV2LXBhcnNlIiwgIkhFQUQiXSwgY3dkPXJv
b3QpCiAgICBpZiBmdWxsX291dCBpcyBOb25lOgogICAgICAgIHJhaXNlIE5v
dFRoaXNNZXRob2QoIidnaXQgcmV2LXBhcnNlJyBmYWlsZWQiKQogICAgZnVs
bF9vdXQgPSBmdWxsX291dC5zdHJpcCgpCgogICAgcGllY2VzID0ge30KICAg
IHBpZWNlc1sibG9uZyJdID0gZnVsbF9vdXQKICAgIHBpZWNlc1sic2hvcnQi
XSA9IGZ1bGxfb3V0Wzo3XSAgIyBtYXliZSBpbXByb3ZlZCBsYXRlcgogICAg
cGllY2VzWyJlcnJvciJdID0gTm9uZQoKICAgICMgcGFyc2UgZGVzY3JpYmVf
b3V0LiBJdCB3aWxsIGJlIGxpa2UgVEFHLU5VTS1nSEVYWy1kaXJ0eV0gb3Ig
SEVYWy1kaXJ0eV0KICAgICMgVEFHIG1pZ2h0IGhhdmUgaHlwaGVucy4KICAg
IGdpdF9kZXNjcmliZSA9IGRlc2NyaWJlX291dAoKICAgICMgbG9vayBmb3Ig
LWRpcnR5IHN1ZmZpeAogICAgZGlydHkgPSBnaXRfZGVzY3JpYmUuZW5kc3dp
dGgoIi1kaXJ0eSIpCiAgICBwaWVjZXNbImRpcnR5Il0gPSBkaXJ0eQogICAg
aWYgZGlydHk6CiAgICAgICAgZ2l0X2Rlc2NyaWJlID0gZ2l0X2Rlc2NyaWJl
WzpnaXRfZGVzY3JpYmUucmluZGV4KCItZGlydHkiKV0KCiAgICAjIG5vdyB3
ZSBoYXZlIFRBRy1OVU0tZ0hFWCBvciBIRVgKCiAgICBpZiAiLSIgaW4gZ2l0
X2Rlc2NyaWJlOgogICAgICAgICMgVEFHLU5VTS1nSEVYCiAgICAgICAgbW8g
PSByZS5zZWFyY2gocideKC4rKS0oXGQrKS1nKFswLTlhLWZdKykkJywgZ2l0
X2Rlc2NyaWJlKQogICAgICAgIGlmIG5vdCBtbzoKICAgICAgICAgICAgIyB1
bnBhcnNlYWJsZS4gTWF5YmUgZ2l0LWRlc2NyaWJlIGlzIG1pc2JlaGF2aW5n
PwogICAgICAgICAgICBwaWVjZXNbImVycm9yIl0gPSAoInVuYWJsZSB0byBw
YXJzZSBnaXQtZGVzY3JpYmUgb3V0cHV0OiAnJSVzJyIKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICUlIGRlc2NyaWJlX291dCkKICAgICAgICAg
ICAgcmV0dXJuIHBpZWNlcwoKICAgICAgICAjIHRhZwogICAgICAgIGZ1bGxf
dGFnID0gbW8uZ3JvdXAoMSkKICAgICAgICBpZiBub3QgZnVsbF90YWcuc3Rh
cnRzd2l0aCh0YWdfcHJlZml4KToKICAgICAgICAgICAgaWYgdmVyYm9zZToK
ICAgICAgICAgICAgICAgIGZtdCA9ICJ0YWcgJyUlcycgZG9lc24ndCBzdGFy
dCB3aXRoIHByZWZpeCAnJSVzJyIKICAgICAgICAgICAgICAgIHByaW50KGZt
dCAlJSAoZnVsbF90YWcsIHRhZ19wcmVmaXgpKQogICAgICAgICAgICBwaWVj
ZXNbImVycm9yIl0gPSAoInRhZyAnJSVzJyBkb2Vzbid0IHN0YXJ0IHdpdGgg
cHJlZml4ICclJXMnIgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
JSUgKGZ1bGxfdGFnLCB0YWdfcHJlZml4KSkKICAgICAgICAgICAgcmV0dXJu
IHBpZWNlcwogICAgICAgIHBpZWNlc1siY2xvc2VzdC10YWciXSA9IGZ1bGxf
dGFnW2xlbih0YWdfcHJlZml4KTpdCgogICAgICAgICMgZGlzdGFuY2U6IG51
bWJlciBvZiBjb21taXRzIHNpbmNlIHRhZwogICAgICAgIHBpZWNlc1siZGlz
dGFuY2UiXSA9IGludChtby5ncm91cCgyKSkKCiAgICAgICAgIyBjb21taXQ6
IHNob3J0IGhleCByZXZpc2lvbiBJRAogICAgICAgIHBpZWNlc1sic2hvcnQi
XSA9IG1vLmdyb3VwKDMpCgogICAgZWxzZToKICAgICAgICAjIEhFWDogbm8g
dGFncwogICAgICAgIHBpZWNlc1siY2xvc2VzdC10YWciXSA9IE5vbmUKICAg
ICAgICBjb3VudF9vdXQsIHJjID0gcnVuX2NvbW1hbmQoR0lUUywgWyJyZXYt
bGlzdCIsICJIRUFEIiwgIi0tY291bnQiXSwKICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgY3dkPXJvb3QpCiAgICAgICAgcGllY2VzWyJk
aXN0YW5jZSJdID0gaW50KGNvdW50X291dCkgICMgdG90YWwgbnVtYmVyIG9m
IGNvbW1pdHMKCiAgICAjIGNvbW1pdCBkYXRlOiBzZWUgSVNPLTg2MDEgY29t
bWVudCBpbiBnaXRfdmVyc2lvbnNfZnJvbV9rZXl3b3JkcygpCiAgICBkYXRl
ID0gcnVuX2NvbW1hbmQoR0lUUywgWyJzaG93IiwgIi1zIiwgIi0tZm9ybWF0
PSUlY2kiLCAiSEVBRCJdLAogICAgICAgICAgICAgICAgICAgICAgIGN3ZD1y
b290KVswXS5zdHJpcCgpCiAgICBwaWVjZXNbImRhdGUiXSA9IGRhdGUuc3Ry
aXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAxKS5yZXBsYWNlKCIgIiwgIiIsIDEp
CgogICAgcmV0dXJuIHBpZWNlcwoKCmRlZiBwbHVzX29yX2RvdChwaWVjZXMp
OgogICAgIiIiUmV0dXJuIGEgKyBpZiB3ZSBkb24ndCBhbHJlYWR5IGhhdmUg
b25lLCBlbHNlIHJldHVybiBhIC4iIiIKICAgIGlmICIrIiBpbiBwaWVjZXMu
Z2V0KCJjbG9zZXN0LXRhZyIsICIiKToKICAgICAgICByZXR1cm4gIi4iCiAg
ICByZXR1cm4gIisiCgoKZGVmIHJlbmRlcl9wZXA0NDAocGllY2VzKToKICAg
ICIiIkJ1aWxkIHVwIHZlcnNpb24gc3RyaW5nLCB3aXRoIHBvc3QtcmVsZWFz
ZSAibG9jYWwgdmVyc2lvbiBpZGVudGlmaWVyIi4KCiAgICBPdXIgZ29hbDog
VEFHWytESVNUQU5DRS5nSEVYWy5kaXJ0eV1dIC4gTm90ZSB0aGF0IGlmIHlv
dQogICAgZ2V0IGEgdGFnZ2VkIGJ1aWxkIGFuZCB0aGVuIGRpcnR5IGl0LCB5
b3UnbGwgZ2V0IFRBRyswLmdIRVguZGlydHkKCiAgICBFeGNlcHRpb25zOgog
ICAgMTogbm8gdGFncy4gZ2l0X2Rlc2NyaWJlIHdhcyBqdXN0IEhFWC4gMCt1
bnRhZ2dlZC5ESVNUQU5DRS5nSEVYWy5kaXJ0eV0KICAgICIiIgogICAgaWYg
cGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0gcGll
Y2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5j
ZSJdIG9yIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQg
Kz0gcGx1c19vcl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCAr
PSAiJSVkLmclJXMiICUlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNlc1si
c2hvcnQiXSkKICAgICAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAg
ICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAgIGVsc2U6CiAg
ICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwK3Vu
dGFnZ2VkLiUlZC5nJSVzIiAlJSAocGllY2VzWyJkaXN0YW5jZSJdLAogICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBwaWVjZXNb
InNob3J0Il0pCiAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAg
ICAgICByZW5kZXJlZCArPSAiLmRpcnR5IgogICAgcmV0dXJuIHJlbmRlcmVk
CgoKZGVmIHJlbmRlcl9wZXA0NDBfcHJlKHBpZWNlcyk6CiAgICAiIiJUQUdb
LnBvc3QuZGV2RElTVEFOQ0VdIC0tIE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRp
b25zOgogICAgMTogbm8gdGFncy4gMC5wb3N0LmRldkRJU1RBTkNFCiAgICAi
IiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICByZW5k
ZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQogICAgICAgIGlmIHBpZWNl
c1siZGlzdGFuY2UiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5wb3N0
LmRldiUlZCIgJSUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICBlbHNlOgogICAg
ICAgICMgZXhjZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMC5wb3N0
LmRldiUlZCIgJSUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICByZXR1cm4gcmVu
ZGVyZWQKCgpkZWYgcmVuZGVyX3BlcDQ0MF9wb3N0KHBpZWNlcyk6CiAgICAi
IiJUQUdbLnBvc3RESVNUQU5DRVsuZGV2MF0rZ0hFWF0gLgoKICAgIFRoZSAi
LmRldjAiIG1lYW5zIGRpcnR5LiBOb3RlIHRoYXQgLmRldjAgc29ydHMgYmFj
a3dhcmRzCiAgICAoYSBkaXJ0eSB0cmVlIHdpbGwgYXBwZWFyICJvbGRlciIg
dGhhbiB0aGUgY29ycmVzcG9uZGluZyBjbGVhbiBvbmUpLAogICAgYnV0IHlv
dSBzaG91bGRuJ3QgYmUgcmVsZWFzaW5nIHNvZnR3YXJlIHdpdGggLWRpcnR5
IGFueXdheXMuCgogICAgRXhjZXB0aW9uczoKICAgIDE6IG5vIHRhZ3MuIDAu
cG9zdERJU1RBTkNFWy5kZXYwXQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNs
b3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nl
c3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0gb3IgcGll
Y2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSAiLnBvc3Ql
JWQiICUlIHBpZWNlc1siZGlzdGFuY2UiXQogICAgICAgICAgICBpZiBwaWVj
ZXNbImRpcnR5Il06CiAgICAgICAgICAgICAgICByZW5kZXJlZCArPSAiLmRl
djAiCiAgICAgICAgICAgIHJlbmRlcmVkICs9IHBsdXNfb3JfZG90KHBpZWNl
cykKICAgICAgICAgICAgcmVuZGVyZWQgKz0gImclJXMiICUlIHBpZWNlc1si
c2hvcnQiXQogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAg
ICAgIHJlbmRlcmVkID0gIjAucG9zdCUlZCIgJSUgcGllY2VzWyJkaXN0YW5j
ZSJdCiAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICBy
ZW5kZXJlZCArPSAiLmRldjAiCiAgICAgICAgcmVuZGVyZWQgKz0gIitnJSVz
IiAlJSBwaWVjZXNbInNob3J0Il0KICAgIHJldHVybiByZW5kZXJlZAoKCmRl
ZiByZW5kZXJfcGVwNDQwX29sZChwaWVjZXMpOgogICAgIiIiVEFHWy5wb3N0
RElTVEFOQ0VbLmRldjBdXSAuCgogICAgVGhlICIuZGV2MCIgbWVhbnMgZGly
dHkuCgogICAgRWV4Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiAwLnBvc3RE
SVNUQU5DRVsuZGV2MF0KICAgICIiIgogICAgaWYgcGllY2VzWyJjbG9zZXN0
LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0gcGllY2VzWyJjbG9zZXN0LXRh
ZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5jZSJdIG9yIHBpZWNlc1si
ZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5wb3N0JSVkIiAl
JSBwaWVjZXNbImRpc3RhbmNlIl0KICAgICAgICAgICAgaWYgcGllY2VzWyJk
aXJ0eSJdOgogICAgICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kZXYwIgog
ICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAgICAgIHJlbmRl
cmVkID0gIjAucG9zdCUlZCIgJSUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICAg
ICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCAr
PSAiLmRldjAiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX3Bl
cDQ0MF9pbmMocGllY2VzKToKICAgICIiIkJ1aWxkIHVwIHZlcnNpb24gc3Ry
aW5nLCBpbmNyZW1lbnRpbmcgdGhlIHBhdGNoIGZpZWxkLCIKCiAgICBPdXIg
Z29hbDogTUFZT1IuTUlOT1IuKFBBVEhDSCsxKS4gTm90ZSB0aGF0IGlmIHlv
dQogICAgZ2V0IGEgdGFnZ2VkIGJ1aWxkIGFuZCB0aGVuIGRpcnR5IGl0LCB5
b3UnbGwgZ2V0IFRBRyswLmdIRVguZGlydHkKCiAgICBFeGNlcHRpb25zOgog
ICAgMTogbm8gdGFncy4gZ2l0X2Rlc2NyaWJlIHdhcyBqdXN0IEhFWC4gMCt1
bnRhZ2dlZC5ESVNUQU5DRS5nSEVYWy5kaXJ0eV0KICAgICIiIgogICAgaWYg
cGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHNwbGl0dGVkID0gcGll
Y2VzWyJjbG9zZXN0LXRhZyJdLnNwbGl0KCcuJykKICAgICAgICBwYXRjaCA9
IGludChzcGxpdHRlZFstMV0pCgogICAgICAgIGlmIHBpZWNlc1siZGlzdGFu
Y2UiXToKICAgICAgICAgICAgcGF0Y2ggKz0gcGllY2VzWyJkaXN0YW5jZSJd
CgogICAgICAgIHJlbmRlcmVkID0gJy4nLmpvaW4oc3BsaXR0ZWRbMDpsZW4o
c3BsaXR0ZWQpLTFdKSArICcuJyArIHN0cihwYXRjaCkKCiAgICAgICAgaWYg
cGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSAiLmRp
cnR5IgogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAgICAg
IHJlbmRlcmVkID0gIjArdW50YWdnZWQuJSVkLmclJXMiICUlIChwaWVjZXNb
ImRpc3RhbmNlIl0sCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgIHBpZWNlc1sic2hvcnQiXSkKICAgICAgICBpZiBwaWVjZXNb
ImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGlydHkiCiAg
ICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX2dpdF9kZXNjcmliZShw
aWVjZXMpOgogICAgIiIiVEFHWy1ESVNUQU5DRS1nSEVYXVstZGlydHldLgoK
ICAgIExpa2UgJ2dpdCBkZXNjcmliZSAtLXRhZ3MgLS1kaXJ0eSAtLWFsd2F5
cycuCgogICAgRXhjZXB0aW9uczoKICAgIDE6IG5vIHRhZ3MuIEhFWFstZGly
dHldICAobm90ZTogbm8gJ2cnIHByZWZpeCkKICAgICIiIgogICAgaWYgcGll
Y2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0gcGllY2Vz
WyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5jZSJd
OgogICAgICAgICAgICByZW5kZXJlZCArPSAiLSUlZC1nJSVzIiAlJSAocGll
Y2VzWyJkaXN0YW5jZSJdLCBwaWVjZXNbInNob3J0Il0pCiAgICBlbHNlOgog
ICAgICAgICMgZXhjZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSBwaWVj
ZXNbInNob3J0Il0KICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICBy
ZW5kZXJlZCArPSAiLWRpcnR5IgogICAgcmV0dXJuIHJlbmRlcmVkCgoKZGVm
IHJlbmRlcl9naXRfZGVzY3JpYmVfbG9uZyhwaWVjZXMpOgogICAgIiIiVEFH
LURJU1RBTkNFLWdIRVhbLWRpcnR5XS4KCiAgICBMaWtlICdnaXQgZGVzY3Jp
YmUgLS10YWdzIC0tZGlydHkgLS1hbHdheXMgLWxvbmcnLgogICAgVGhlIGRp
c3RhbmNlL2hhc2ggaXMgdW5jb25kaXRpb25hbC4KCiAgICBFeGNlcHRpb25z
OgogICAgMTogbm8gdGFncy4gSEVYWy1kaXJ0eV0gIChub3RlOiBubyAnZycg
cHJlZml4KQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06
CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAg
ICAgICByZW5kZXJlZCArPSAiLSUlZC1nJSVzIiAlJSAocGllY2VzWyJkaXN0
YW5jZSJdLCBwaWVjZXNbInNob3J0Il0pCiAgICBlbHNlOgogICAgICAgICMg
ZXhjZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbInNob3J0
Il0KICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICByZW5kZXJlZCAr
PSAiLWRpcnR5IgogICAgcmV0dXJuIHJlbmRlcmVkCgoKZGVmIHJlbmRlcihw
aWVjZXMsIHN0eWxlKToKICAgICIiIlJlbmRlciB0aGUgZ2l2ZW4gdmVyc2lv
biBwaWVjZXMgaW50byB0aGUgcmVxdWVzdGVkIHN0eWxlLiIiIgogICAgaWYg
cGllY2VzWyJlcnJvciJdOgogICAgICAgIHJldHVybiB7InZlcnNpb24iOiAi
dW5rbm93biIsCiAgICAgICAgICAgICAgICAiZnVsbC1yZXZpc2lvbmlkIjog
cGllY2VzLmdldCgibG9uZyIpLAogICAgICAgICAgICAgICAgImRpcnR5Ijog
Tm9uZSwKICAgICAgICAgICAgICAgICJlcnJvciI6IHBpZWNlc1siZXJyb3Ii
XSwKICAgICAgICAgICAgICAgICJkYXRlIjogTm9uZX0KCiAgICBpZiBub3Qg
c3R5bGUgb3Igc3R5bGUgPT0gImRlZmF1bHQiOgogICAgICAgIHN0eWxlID0g
InBlcDQ0MCIgICMgdGhlIGRlZmF1bHQKCiAgICBpZiBzdHlsZSA9PSAicGVw
NDQwIjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRlcl9wZXA0NDAocGllY2Vz
KQogICAgZWxpZiBzdHlsZSA9PSAicGVwNDQwLXByZSI6CiAgICAgICAgcmVu
ZGVyZWQgPSByZW5kZXJfcGVwNDQwX3ByZShwaWVjZXMpCiAgICBlbGlmIHN0
eWxlID09ICJwZXA0NDAtcG9zdCI6CiAgICAgICAgcmVuZGVyZWQgPSByZW5k
ZXJfcGVwNDQwX3Bvc3QocGllY2VzKQogICAgZWxpZiBzdHlsZSA9PSAicGVw
NDQwLW9sZCI6CiAgICAgICAgcmVuZGVyZWQgPSByZW5kZXJfcGVwNDQwX29s
ZChwaWVjZXMpCiAgICBlbGlmIHN0eWxlID09ICJwZXA0NDAtaW5jIjoKICAg
ICAgICByZW5kZXJlZCA9IHJlbmRlcl9wZXA0NDBfaW5jKHBpZWNlcykKICAg
IGVsaWYgc3R5bGUgPT0gImdpdC1kZXNjcmliZSI6CiAgICAgICAgcmVuZGVy
ZWQgPSByZW5kZXJfZ2l0X2Rlc2NyaWJlKHBpZWNlcykKICAgIGVsaWYgc3R5
bGUgPT0gImdpdC1kZXNjcmliZS1sb25nIjoKICAgICAgICByZW5kZXJlZCA9
IHJlbmRlcl9naXRfZGVzY3JpYmVfbG9uZyhwaWVjZXMpCiAgICBlbHNlOgog
ICAgICAgIHJhaXNlIFZhbHVlRXJyb3IoInVua25vd24gc3R5bGUgJyUlcyci
ICUlIHN0eWxlKQoKICAgIHJldHVybiB7InZlcnNpb24iOiByZW5kZXJlZCwg
ImZ1bGwtcmV2aXNpb25pZCI6IHBpZWNlc1sibG9uZyJdLAogICAgICAgICAg
ICAiZGlydHkiOiBwaWVjZXNbImRpcnR5Il0sICJlcnJvciI6IE5vbmUsCiAg
ICAgICAgICAgICJkYXRlIjogcGllY2VzLmdldCgiZGF0ZSIpfQoKZGVmIGdl
dF92ZXJzaW9ucygpOgogICAgIiIiR2V0IHZlcnNpb24gaW5mb3JtYXRpb24g
b3IgcmV0dXJuIGRlZmF1bHQgaWYgdW5hYmxlIHRvIGRvIHNvLiIiIgogICAg
IyBJIGFtIGluIF92ZXJzaW9uLnB5LCB3aGljaCBsaXZlcyBhdCBST09UL1ZF
UlNJT05GSUxFX1NPVVJDRS4gSWYgd2UgaGF2ZQogICAgIyBfX2ZpbGVfXywg
d2UgY2FuIHdvcmsgYmFja3dhcmRzIGZyb20gdGhlcmUgdG8gdGhlIHJvb3Qu
IFNvbWUKICAgICMgcHkyZXhlL2JiZnJlZXplL25vbi1DUHl0aG9uIGltcGxl
bWVudGF0aW9ucyBkb24ndCBkbyBfX2ZpbGVfXywgaW4gd2hpY2gKICAgICMg
Y2FzZSB3ZSBjYW4gb25seSB1c2UgZXhwYW5kZWQga2V5d29yZHMuCgogICAg
Y2ZnID0gZ2V0X2NvbmZpZygpCiAgICB2ZXJib3NlID0gY2ZnLnZlcmJvc2UK
CiAgICB0cnk6CiAgICAgICAgcmV0dXJuIGdpdF92ZXJzaW9uc19mcm9tX2tl
eXdvcmRzKGdldF9rZXl3b3JkcygpLCBjZmcudGFnX3ByZWZpeCwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgdmVyYm9zZSkK
ICAgIGV4Y2VwdCBOb3RUaGlzTWV0aG9kOgogICAgICAgIHBhc3MKCiAgICB0
cnk6CiAgICAgICAgcm9vdCA9IG9zLnBhdGgucmVhbHBhdGgoX19maWxlX18p
CiAgICAgICAgIyB2ZXJzaW9uZmlsZV9zb3VyY2UgaXMgdGhlIHJlbGF0aXZl
IHBhdGggZnJvbSB0aGUgdG9wIG9mIHRoZSBzb3VyY2UKICAgICAgICAjIHRy
ZWUgKHdoZXJlIHRoZSAuZ2l0IGRpcmVjdG9yeSBtaWdodCBsaXZlKSB0byB0
aGlzIGZpbGUuIEludmVydAogICAgICAgICMgdGhpcyB0byBmaW5kIHRoZSBy
b290IGZyb20gX19maWxlX18uCiAgICAgICAgZm9yIGkgaW4gY2ZnLnZlcnNp
b25maWxlX3NvdXJjZS5zcGxpdCgnLycpOgogICAgICAgICAgICByb290ID0g
b3MucGF0aC5kaXJuYW1lKHJvb3QpCiAgICBleGNlcHQgTmFtZUVycm9yOgog
ICAgICAgIHJldHVybiB7InZlcnNpb24iOiAiMCt1bmtub3duIiwgImZ1bGwt
cmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAgICAgICAgICAiZGlydHkiOiBO
b25lLAogICAgICAgICAgICAgICAgImVycm9yIjogInVuYWJsZSB0byBmaW5k
IHJvb3Qgb2Ygc291cmNlIHRyZWUiLAogICAgICAgICAgICAgICAgImRhdGUi
OiBOb25lfQoKICAgIHRyeToKICAgICAgICBwaWVjZXMgPSBnaXRfcGllY2Vz
X2Zyb21fdmNzKGNmZy50YWdfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAg
ICAgIHJldHVybiByZW5kZXIocGllY2VzLCBjZmcuc3R5bGUpCiAgICBleGNl
cHQgTm90VGhpc01ldGhvZDoKICAgICAgICBwYXNzCgogICAgdHJ5OgogICAg
ICAgIGlmIGNmZy5wYXJlbnRkaXJfcHJlZml4OgogICAgICAgICAgICByZXR1
cm4gdmVyc2lvbnNfZnJvbV9wYXJlbnRkaXIoY2ZnLnBhcmVudGRpcl9wcmVm
aXgsIHJvb3QsIHZlcmJvc2UpCiAgICBleGNlcHQgTm90VGhpc01ldGhvZDoK
ICAgICAgICBwYXNzCgogICAgcmV0dXJuIHsidmVyc2lvbiI6ICIwK3Vua25v
d24iLCAiZnVsbC1yZXZpc2lvbmlkIjogTm9uZSwKICAgICAgICAgICAgImRp
cnR5IjogTm9uZSwKICAgICAgICAgICAgImVycm9yIjogInVuYWJsZSB0byBj
b21wdXRlIHZlcnNpb24iLCAiZGF0ZSI6IE5vbmV9CicnJwoKCkByZWdpc3Rl
cl92Y3NfaGFuZGxlcigiZ2l0IiwgImdldF9rZXl3b3JkcyIpCmRlZiBnaXRf
Z2V0X2tleXdvcmRzKHZlcnNpb25maWxlX2Ficyk6CiAgICAiIiJFeHRyYWN0
IHZlcnNpb24gaW5mb3JtYXRpb24gZnJvbSB0aGUgZ2l2ZW4gZmlsZS4iIiIK
ICAgICMgdGhlIGNvZGUgZW1iZWRkZWQgaW4gX3ZlcnNpb24ucHkgY2FuIGp1
c3QgZmV0Y2ggdGhlIHZhbHVlIG9mIHRoZXNlCiAgICAjIGtleXdvcmRzLiBX
aGVuIHVzZWQgZnJvbSBzZXR1cC5weSwgd2UgZG9uJ3Qgd2FudCB0byBpbXBv
cnQgX3ZlcnNpb24ucHksCiAgICAjIHNvIHdlIGRvIGl0IHdpdGggYSByZWdl
eHAgaW5zdGVhZC4gVGhpcyBmdW5jdGlvbiBpcyBub3QgdXNlZCBmcm9tCiAg
ICAjIF92ZXJzaW9uLnB5LgogICAga2V5d29yZHMgPSB7fQogICAgdHJ5Ogog
ICAgICAgIGYgPSBvcGVuKHZlcnNpb25maWxlX2FicywgInIiKQogICAgICAg
IGZvciBsaW5lIGluIGYucmVhZGxpbmVzKCk6CiAgICAgICAgICAgIGlmIGxp
bmUuc3RyaXAoKS5zdGFydHN3aXRoKCJnaXRfcmVmbmFtZXMgPSIpOgogICAg
ICAgICAgICAgICAgbW8gPSByZS5zZWFyY2gocic9XHMqIiguKikiJywgbGlu
ZSkKICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAgICAgICAgICAg
IGtleXdvcmRzWyJyZWZuYW1lcyJdID0gbW8uZ3JvdXAoMSkKICAgICAgICAg
ICAgaWYgbGluZS5zdHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9mdWxsID0iKToK
ICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxzKiIoLiopIics
IGxpbmUpCiAgICAgICAgICAgICAgICBpZiBtbzoKICAgICAgICAgICAgICAg
ICAgICBrZXl3b3Jkc1siZnVsbCJdID0gbW8uZ3JvdXAoMSkKICAgICAgICAg
ICAgaWYgbGluZS5zdHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9kYXRlID0iKToK
ICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxzKiIoLiopIics
IGxpbmUpCiAgICAgICAgICAgICAgICBpZiBtbzoKICAgICAgICAgICAgICAg
ICAgICBrZXl3b3Jkc1siZGF0ZSJdID0gbW8uZ3JvdXAoMSkKICAgICAgICBm
LmNsb3NlKCkKICAgIGV4Y2VwdCBFbnZpcm9ubWVudEVycm9yOgogICAgICAg
IHBhc3MKICAgIHJldHVybiBrZXl3b3JkcwoKCkByZWdpc3Rlcl92Y3NfaGFu
ZGxlcigiZ2l0IiwgImtleXdvcmRzIikKZGVmIGdpdF92ZXJzaW9uc19mcm9t
X2tleXdvcmRzKGtleXdvcmRzLCB0YWdfcHJlZml4LCB2ZXJib3NlKToKICAg
ICIiIkdldCB2ZXJzaW9uIGluZm9ybWF0aW9uIGZyb20gZ2l0IGtleXdvcmRz
LiIiIgogICAgaWYgbm90IGtleXdvcmRzOgogICAgICAgIHJhaXNlIE5vdFRo
aXNNZXRob2QoIm5vIGtleXdvcmRzIGF0IGFsbCwgd2VpcmQiKQogICAgZGF0
ZSA9IGtleXdvcmRzLmdldCgiZGF0ZSIpCiAgICBpZiBkYXRlIGlzIG5vdCBO
b25lOgogICAgICAgICMgZ2l0LTIuMi4wIGFkZGVkICIlY0kiLCB3aGljaCBl
eHBhbmRzIHRvIGFuIElTTy04NjAxIC1jb21wbGlhbnQKICAgICAgICAjIGRh
dGVzdGFtcC4gSG93ZXZlciB3ZSBwcmVmZXIgIiVjaSIgKHdoaWNoIGV4cGFu
ZHMgdG8gYW4gIklTTy04NjAxCiAgICAgICAgIyAtbGlrZSIgc3RyaW5nLCB3
aGljaCB3ZSBtdXN0IHRoZW4gZWRpdCB0byBtYWtlIGNvbXBsaWFudCksIGJl
Y2F1c2UKICAgICAgICAjIGl0J3MgYmVlbiBhcm91bmQgc2luY2UgZ2l0LTEu
NS4zLCBhbmQgaXQncyB0b28gZGlmZmljdWx0IHRvCiAgICAgICAgIyBkaXNj
b3ZlciB3aGljaCB2ZXJzaW9uIHdlJ3JlIHVzaW5nLCBvciB0byB3b3JrIGFy
b3VuZCB1c2luZyBhbgogICAgICAgICMgb2xkZXIgb25lLgogICAgICAgIGRh
dGUgPSBkYXRlLnN0cmlwKCkucmVwbGFjZSgiICIsICJUIiwgMSkucmVwbGFj
ZSgiICIsICIiLCAxKQogICAgcmVmbmFtZXMgPSBrZXl3b3Jkc1sicmVmbmFt
ZXMiXS5zdHJpcCgpCiAgICBpZiByZWZuYW1lcy5zdGFydHN3aXRoKCIkRm9y
bWF0Iik6CiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgcHJpbnQo
ImtleXdvcmRzIGFyZSB1bmV4cGFuZGVkLCBub3QgdXNpbmciKQogICAgICAg
IHJhaXNlIE5vdFRoaXNNZXRob2QoInVuZXhwYW5kZWQga2V5d29yZHMsIG5v
dCBhIGdpdC1hcmNoaXZlIHRhcmJhbGwiKQogICAgcmVmcyA9IHNldChbci5z
dHJpcCgpIGZvciByIGluIHJlZm5hbWVzLnN0cmlwKCIoKSIpLnNwbGl0KCIs
IildKQogICAgIyBzdGFydGluZyBpbiBnaXQtMS44LjMsIHRhZ3MgYXJlIGxp
c3RlZCBhcyAidGFnOiBmb28tMS4wIiBpbnN0ZWFkIG9mCiAgICAjIGp1c3Qg
ImZvby0xLjAiLiBJZiB3ZSBzZWUgYSAidGFnOiAiIHByZWZpeCwgcHJlZmVy
IHRob3NlLgogICAgVEFHID0gInRhZzogIgogICAgdGFncyA9IHNldChbclts
ZW4oVEFHKTpdIGZvciByIGluIHJlZnMgaWYgci5zdGFydHN3aXRoKFRBRyld
KQogICAgaWYgbm90IHRhZ3M6CiAgICAgICAgIyBFaXRoZXIgd2UncmUgdXNp
bmcgZ2l0IDwgMS44LjMsIG9yIHRoZXJlIHJlYWxseSBhcmUgbm8gdGFncy4g
V2UgdXNlCiAgICAgICAgIyBhIGhldXJpc3RpYzogYXNzdW1lIGFsbCB2ZXJz
aW9uIHRhZ3MgaGF2ZSBhIGRpZ2l0LiBUaGUgb2xkIGdpdCAlZAogICAgICAg
ICMgZXhwYW5zaW9uIGJlaGF2ZXMgbGlrZSBnaXQgbG9nIC0tZGVjb3JhdGU9
c2hvcnQgYW5kIHN0cmlwcyBvdXQgdGhlCiAgICAgICAgIyByZWZzL2hlYWRz
LyBhbmQgcmVmcy90YWdzLyBwcmVmaXhlcyB0aGF0IHdvdWxkIGxldCB1cyBk
aXN0aW5ndWlzaAogICAgICAgICMgYmV0d2VlbiBicmFuY2hlcyBhbmQgdGFn
cy4gQnkgaWdub3JpbmcgcmVmbmFtZXMgd2l0aG91dCBkaWdpdHMsIHdlCiAg
ICAgICAgIyBmaWx0ZXIgb3V0IG1hbnkgY29tbW9uIGJyYW5jaCBuYW1lcyBs
aWtlICJyZWxlYXNlIiBhbmQKICAgICAgICAjICJzdGFiaWxpemF0aW9uIiwg
YXMgd2VsbCBhcyAiSEVBRCIgYW5kICJtYXN0ZXIiLgogICAgICAgIHRhZ3Mg
PSBzZXQoW3IgZm9yIHIgaW4gcmVmcyBpZiByZS5zZWFyY2gocidcZCcsIHIp
XSkKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgiZGlz
Y2FyZGluZyAnJXMnLCBubyBkaWdpdHMiICUgIiwiLmpvaW4ocmVmcyAtIHRh
Z3MpKQogICAgaWYgdmVyYm9zZToKICAgICAgICBwcmludCgibGlrZWx5IHRh
Z3M6ICVzIiAlICIsIi5qb2luKHNvcnRlZCh0YWdzKSkpCiAgICBmb3IgcmVm
IGluIHNvcnRlZCh0YWdzKToKICAgICAgICAjIHNvcnRpbmcgd2lsbCBwcmVm
ZXIgZS5nLiAiMi4wIiBvdmVyICIyLjByYzEiCiAgICAgICAgaWYgcmVmLnN0
YXJ0c3dpdGgodGFnX3ByZWZpeCk6CiAgICAgICAgICAgIHIgPSByZWZbbGVu
KHRhZ19wcmVmaXgpOl0KICAgICAgICAgICAgaWYgdmVyYm9zZToKICAgICAg
ICAgICAgICAgIHByaW50KCJwaWNraW5nICVzIiAlIHIpCiAgICAgICAgICAg
IHJldHVybiB7InZlcnNpb24iOiByLAogICAgICAgICAgICAgICAgICAgICJm
dWxsLXJldmlzaW9uaWQiOiBrZXl3b3Jkc1siZnVsbCJdLnN0cmlwKCksCiAg
ICAgICAgICAgICAgICAgICAgImRpcnR5IjogRmFsc2UsICJlcnJvciI6IE5v
bmUsCiAgICAgICAgICAgICAgICAgICAgImRhdGUiOiBkYXRlfQogICAgIyBu
byBzdWl0YWJsZSB0YWdzLCBzbyB2ZXJzaW9uIGlzICIwK3Vua25vd24iLCBi
dXQgZnVsbCBoZXggaXMgc3RpbGwgdGhlcmUKICAgIGlmIHZlcmJvc2U6CiAg
ICAgICAgcHJpbnQoIm5vIHN1aXRhYmxlIHRhZ3MsIHVzaW5nIHVua25vd24g
KyBmdWxsIHJldmlzaW9uIGlkIikKICAgIHJldHVybiB7InZlcnNpb24iOiAi
MCt1bmtub3duIiwKICAgICAgICAgICAgImZ1bGwtcmV2aXNpb25pZCI6IGtl
eXdvcmRzWyJmdWxsIl0uc3RyaXAoKSwKICAgICAgICAgICAgImRpcnR5Ijog
RmFsc2UsICJlcnJvciI6ICJubyBzdWl0YWJsZSB0YWdzIiwgImRhdGUiOiBO
b25lfQoKCkByZWdpc3Rlcl92Y3NfaGFuZGxlcigiZ2l0IiwgInBpZWNlc19m
cm9tX3ZjcyIpCmRlZiBnaXRfcGllY2VzX2Zyb21fdmNzKHRhZ19wcmVmaXgs
IHJvb3QsIHZlcmJvc2UsIHJ1bl9jb21tYW5kPXJ1bl9jb21tYW5kKToKICAg
ICIiIkdldCB2ZXJzaW9uIGZyb20gJ2dpdCBkZXNjcmliZScgaW4gdGhlIHJv
b3Qgb2YgdGhlIHNvdXJjZSB0cmVlLgoKICAgIFRoaXMgb25seSBnZXRzIGNh
bGxlZCBpZiB0aGUgZ2l0LWFyY2hpdmUgJ3N1YnN0JyBrZXl3b3JkcyB3ZXJl
ICpub3QqCiAgICBleHBhbmRlZCwgYW5kIF92ZXJzaW9uLnB5IGhhc24ndCBh
bHJlYWR5IGJlZW4gcmV3cml0dGVuIHdpdGggYSBzaG9ydAogICAgdmVyc2lv
biBzdHJpbmcsIG1lYW5pbmcgd2UncmUgaW5zaWRlIGEgY2hlY2tlZCBvdXQg
c291cmNlIHRyZWUuCiAgICAiIiIKICAgIEdJVFMgPSBbImdpdCJdCiAgICBp
ZiBzeXMucGxhdGZvcm0gPT0gIndpbjMyIjoKICAgICAgICBHSVRTID0gWyJn
aXQuY21kIiwgImdpdC5leGUiXQoKICAgIG91dCwgcmMgPSBydW5fY29tbWFu
ZChHSVRTLCBbInJldi1wYXJzZSIsICItLWdpdC1kaXIiXSwgY3dkPXJvb3Qs
CiAgICAgICAgICAgICAgICAgICAgICAgICAgaGlkZV9zdGRlcnI9VHJ1ZSkK
ICAgIGlmIHJjICE9IDA6CiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAg
ICAgcHJpbnQoIkRpcmVjdG9yeSAlcyBub3QgdW5kZXIgZ2l0IGNvbnRyb2wi
ICUgcm9vdCkKICAgICAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCInZ2l0IHJl
di1wYXJzZSAtLWdpdC1kaXInIHJldHVybmVkIGVycm9yIikKCiAgICAjIGlm
IHRoZXJlIGlzIGEgdGFnIG1hdGNoaW5nIHRhZ19wcmVmaXgsIHRoaXMgeWll
bGRzIFRBRy1OVU0tZ0hFWFstZGlydHldCiAgICAjIGlmIHRoZXJlIGlzbid0
IG9uZSwgdGhpcyB5aWVsZHMgSEVYWy1kaXJ0eV0gKG5vIE5VTSkKICAgIGRl
c2NyaWJlX291dCwgcmMgPSBydW5fY29tbWFuZChHSVRTLCBbImRlc2NyaWJl
IiwgIi0tdGFncyIsICItLWRpcnR5IiwKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgIi0tYWx3YXlzIiwgIi0tbG9uZyIsCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICItLW1h
dGNoIiwgIiVzKiIgJSB0YWdfcHJlZml4XSwKICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICBjd2Q9cm9vdCkKICAgICMgLS1sb25nIHdhcyBh
ZGRlZCBpbiBnaXQtMS41LjUKICAgIGlmIGRlc2NyaWJlX291dCBpcyBOb25l
OgogICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoIidnaXQgZGVzY3JpYmUn
IGZhaWxlZCIpCiAgICBkZXNjcmliZV9vdXQgPSBkZXNjcmliZV9vdXQuc3Ry
aXAoKQogICAgZnVsbF9vdXQsIHJjID0gcnVuX2NvbW1hbmQoR0lUUywgWyJy
ZXYtcGFyc2UiLCAiSEVBRCJdLCBjd2Q9cm9vdCkKICAgIGlmIGZ1bGxfb3V0
IGlzIE5vbmU6CiAgICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgiJ2dpdCBy
ZXYtcGFyc2UnIGZhaWxlZCIpCiAgICBmdWxsX291dCA9IGZ1bGxfb3V0LnN0
cmlwKCkKCiAgICBwaWVjZXMgPSB7fQogICAgcGllY2VzWyJsb25nIl0gPSBm
dWxsX291dAogICAgcGllY2VzWyJzaG9ydCJdID0gZnVsbF9vdXRbOjddICAj
IG1heWJlIGltcHJvdmVkIGxhdGVyCiAgICBwaWVjZXNbImVycm9yIl0gPSBO
b25lCgogICAgIyBwYXJzZSBkZXNjcmliZV9vdXQuIEl0IHdpbGwgYmUgbGlr
ZSBUQUctTlVNLWdIRVhbLWRpcnR5XSBvciBIRVhbLWRpcnR5XQogICAgIyBU
QUcgbWlnaHQgaGF2ZSBoeXBoZW5zLgogICAgZ2l0X2Rlc2NyaWJlID0gZGVz
Y3JpYmVfb3V0CgogICAgIyBsb29rIGZvciAtZGlydHkgc3VmZml4CiAgICBk
aXJ0eSA9IGdpdF9kZXNjcmliZS5lbmRzd2l0aCgiLWRpcnR5IikKICAgIHBp
ZWNlc1siZGlydHkiXSA9IGRpcnR5CiAgICBpZiBkaXJ0eToKICAgICAgICBn
aXRfZGVzY3JpYmUgPSBnaXRfZGVzY3JpYmVbOmdpdF9kZXNjcmliZS5yaW5k
ZXgoIi1kaXJ0eSIpXQoKICAgICMgbm93IHdlIGhhdmUgVEFHLU5VTS1nSEVY
IG9yIEhFWAoKICAgIGlmICItIiBpbiBnaXRfZGVzY3JpYmU6CiAgICAgICAg
IyBUQUctTlVNLWdIRVgKICAgICAgICBtbyA9IHJlLnNlYXJjaChyJ14oLisp
LShcZCspLWcoWzAtOWEtZl0rKSQnLCBnaXRfZGVzY3JpYmUpCiAgICAgICAg
aWYgbm90IG1vOgogICAgICAgICAgICAjIHVucGFyc2VhYmxlLiBNYXliZSBn
aXQtZGVzY3JpYmUgaXMgbWlzYmVoYXZpbmc/CiAgICAgICAgICAgIHBpZWNl
c1siZXJyb3IiXSA9ICgidW5hYmxlIHRvIHBhcnNlIGdpdC1kZXNjcmliZSBv
dXRwdXQ6ICclcyciCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAl
IGRlc2NyaWJlX291dCkKICAgICAgICAgICAgcmV0dXJuIHBpZWNlcwoKICAg
ICAgICAjIHRhZwogICAgICAgIGZ1bGxfdGFnID0gbW8uZ3JvdXAoMSkKICAg
ICAgICBpZiBub3QgZnVsbF90YWcuc3RhcnRzd2l0aCh0YWdfcHJlZml4KToK
ICAgICAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgICAgIGZtdCA9
ICJ0YWcgJyVzJyBkb2Vzbid0IHN0YXJ0IHdpdGggcHJlZml4ICclcyciCiAg
ICAgICAgICAgICAgICBwcmludChmbXQgJSAoZnVsbF90YWcsIHRhZ19wcmVm
aXgpKQogICAgICAgICAgICBwaWVjZXNbImVycm9yIl0gPSAoInRhZyAnJXMn
IGRvZXNuJ3Qgc3RhcnQgd2l0aCBwcmVmaXggJyVzJyIKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICUgKGZ1bGxfdGFnLCB0YWdfcHJlZml4KSkK
ICAgICAgICAgICAgcmV0dXJuIHBpZWNlcwogICAgICAgIHBpZWNlc1siY2xv
c2VzdC10YWciXSA9IGZ1bGxfdGFnW2xlbih0YWdfcHJlZml4KTpdCgogICAg
ICAgICMgZGlzdGFuY2U6IG51bWJlciBvZiBjb21taXRzIHNpbmNlIHRhZwog
ICAgICAgIHBpZWNlc1siZGlzdGFuY2UiXSA9IGludChtby5ncm91cCgyKSkK
CiAgICAgICAgIyBjb21taXQ6IHNob3J0IGhleCByZXZpc2lvbiBJRAogICAg
ICAgIHBpZWNlc1sic2hvcnQiXSA9IG1vLmdyb3VwKDMpCgogICAgZWxzZToK
ICAgICAgICAjIEhFWDogbm8gdGFncwogICAgICAgIHBpZWNlc1siY2xvc2Vz
dC10YWciXSA9IE5vbmUKICAgICAgICBjb3VudF9vdXQsIHJjID0gcnVuX2Nv
bW1hbmQoR0lUUywgWyJyZXYtbGlzdCIsICJIRUFEIiwgIi0tY291bnQiXSwK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgY3dkPXJvb3Qp
CiAgICAgICAgcGllY2VzWyJkaXN0YW5jZSJdID0gaW50KGNvdW50X291dCkg
ICMgdG90YWwgbnVtYmVyIG9mIGNvbW1pdHMKCiAgICAjIGNvbW1pdCBkYXRl
OiBzZWUgSVNPLTg2MDEgY29tbWVudCBpbiBnaXRfdmVyc2lvbnNfZnJvbV9r
ZXl3b3JkcygpCiAgICBkYXRlID0gcnVuX2NvbW1hbmQoR0lUUywgWyJzaG93
IiwgIi1zIiwgIi0tZm9ybWF0PSVjaSIsICJIRUFEIl0sCiAgICAgICAgICAg
ICAgICAgICAgICAgY3dkPXJvb3QpWzBdLnN0cmlwKCkKICAgIHBpZWNlc1si
ZGF0ZSJdID0gZGF0ZS5zdHJpcCgpLnJlcGxhY2UoIiAiLCAiVCIsIDEpLnJl
cGxhY2UoIiAiLCAiIiwgMSkKCiAgICByZXR1cm4gcGllY2VzCgoKZGVmIGRv
X3Zjc19pbnN0YWxsKG1hbmlmZXN0X2luLCB2ZXJzaW9uZmlsZV9zb3VyY2Us
IGlweSk6CiAgICAiIiJHaXQtc3BlY2lmaWMgaW5zdGFsbGF0aW9uIGxvZ2lj
IGZvciBWZXJzaW9uZWVyLgoKICAgIEZvciBHaXQsIHRoaXMgbWVhbnMgY3Jl
YXRpbmcvY2hhbmdpbmcgLmdpdGF0dHJpYnV0ZXMgdG8gbWFyayBfdmVyc2lv
bi5weQogICAgZm9yIGV4cG9ydC1zdWJzdCBrZXl3b3JkIHN1YnN0aXR1dGlv
bi4KICAgICIiIgogICAgR0lUUyA9IFsiZ2l0Il0KICAgIGlmIHN5cy5wbGF0
Zm9ybSA9PSAid2luMzIiOgogICAgICAgIEdJVFMgPSBbImdpdC5jbWQiLCAi
Z2l0LmV4ZSJdCiAgICBmaWxlcyA9IFttYW5pZmVzdF9pbiwgdmVyc2lvbmZp
bGVfc291cmNlXQogICAgaWYgaXB5OgogICAgICAgIGZpbGVzLmFwcGVuZChp
cHkpCiAgICB0cnk6CiAgICAgICAgbWUgPSBfX2ZpbGVfXwogICAgICAgIGlm
IG1lLmVuZHN3aXRoKCIucHljIikgb3IgbWUuZW5kc3dpdGgoIi5weW8iKToK
ICAgICAgICAgICAgbWUgPSBvcy5wYXRoLnNwbGl0ZXh0KG1lKVswXSArICIu
cHkiCiAgICAgICAgdmVyc2lvbmVlcl9maWxlID0gb3MucGF0aC5yZWxwYXRo
KG1lKQogICAgZXhjZXB0IE5hbWVFcnJvcjoKICAgICAgICB2ZXJzaW9uZWVy
X2ZpbGUgPSAidmVyc2lvbmVlci5weSIKICAgIGZpbGVzLmFwcGVuZCh2ZXJz
aW9uZWVyX2ZpbGUpCiAgICBwcmVzZW50ID0gRmFsc2UKICAgIHRyeToKICAg
ICAgICBmID0gb3BlbigiLmdpdGF0dHJpYnV0ZXMiLCAiciIpCiAgICAgICAg
Zm9yIGxpbmUgaW4gZi5yZWFkbGluZXMoKToKICAgICAgICAgICAgaWYgbGlu
ZS5zdHJpcCgpLnN0YXJ0c3dpdGgodmVyc2lvbmZpbGVfc291cmNlKToKICAg
ICAgICAgICAgICAgIGlmICJleHBvcnQtc3Vic3QiIGluIGxpbmUuc3RyaXAo
KS5zcGxpdCgpWzE6XToKICAgICAgICAgICAgICAgICAgICBwcmVzZW50ID0g
VHJ1ZQogICAgICAgIGYuY2xvc2UoKQogICAgZXhjZXB0IEVudmlyb25tZW50
RXJyb3I6CiAgICAgICAgcGFzcwogICAgaWYgbm90IHByZXNlbnQ6CiAgICAg
ICAgZiA9IG9wZW4oIi5naXRhdHRyaWJ1dGVzIiwgImErIikKICAgICAgICBm
LndyaXRlKCIlcyBleHBvcnQtc3Vic3RcbiIgJSB2ZXJzaW9uZmlsZV9zb3Vy
Y2UpCiAgICAgICAgZi5jbG9zZSgpCiAgICAgICAgZmlsZXMuYXBwZW5kKCIu
Z2l0YXR0cmlidXRlcyIpCiAgICBydW5fY29tbWFuZChHSVRTLCBbImFkZCIs
ICItLSJdICsgZmlsZXMpCgoKZGVmIHZlcnNpb25zX2Zyb21fcGFyZW50ZGly
KHBhcmVudGRpcl9wcmVmaXgsIHJvb3QsIHZlcmJvc2UpOgogICAgIiIiVHJ5
IHRvIGRldGVybWluZSB0aGUgdmVyc2lvbiBmcm9tIHRoZSBwYXJlbnQgZGly
ZWN0b3J5IG5hbWUuCgogICAgU291cmNlIHRhcmJhbGxzIGNvbnZlbnRpb25h
bGx5IHVucGFjayBpbnRvIGEgZGlyZWN0b3J5IHRoYXQgaW5jbHVkZXMgYm90
aAogICAgdGhlIHByb2plY3QgbmFtZSBhbmQgYSB2ZXJzaW9uIHN0cmluZy4g
V2Ugd2lsbCBhbHNvIHN1cHBvcnQgc2VhcmNoaW5nIHVwCiAgICB0d28gZGly
ZWN0b3J5IGxldmVscyBmb3IgYW4gYXBwcm9wcmlhdGVseSBuYW1lZCBwYXJl
bnQgZGlyZWN0b3J5CiAgICAiIiIKICAgIHJvb3RkaXJzID0gW10KCiAgICBm
b3IgaSBpbiByYW5nZSgzKToKICAgICAgICBkaXJuYW1lID0gb3MucGF0aC5i
YXNlbmFtZShyb290KQogICAgICAgIGlmIGRpcm5hbWUuc3RhcnRzd2l0aChw
YXJlbnRkaXJfcHJlZml4KToKICAgICAgICAgICAgcmV0dXJuIHsidmVyc2lv
biI6IGRpcm5hbWVbbGVuKHBhcmVudGRpcl9wcmVmaXgpOl0sCiAgICAgICAg
ICAgICAgICAgICAgImZ1bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAg
ICAgICAgICAgICAgImRpcnR5IjogRmFsc2UsICJlcnJvciI6IE5vbmUsICJk
YXRlIjogTm9uZX0KICAgICAgICBlbHNlOgogICAgICAgICAgICByb290ZGly
cy5hcHBlbmQocm9vdCkKICAgICAgICAgICAgcm9vdCA9IG9zLnBhdGguZGly
bmFtZShyb290KSAgIyB1cCBhIGxldmVsCgogICAgaWYgdmVyYm9zZToKICAg
ICAgICBwcmludCgiVHJpZWQgZGlyZWN0b3JpZXMgJXMgYnV0IG5vbmUgc3Rh
cnRlZCB3aXRoIHByZWZpeCAlcyIgJQogICAgICAgICAgICAgIChzdHIocm9v
dGRpcnMpLCBwYXJlbnRkaXJfcHJlZml4KSkKICAgIHJhaXNlIE5vdFRoaXNN
ZXRob2QoInJvb3RkaXIgZG9lc24ndCBzdGFydCB3aXRoIHBhcmVudGRpcl9w
cmVmaXgiKQoKClNIT1JUX1ZFUlNJT05fUFkgPSAiIiIKIyBUaGlzIGZpbGUg
d2FzIGdlbmVyYXRlZCBieSAndmVyc2lvbmVlci5weScgKDAuMTguMSkgZnJv
bQojIHJldmlzaW9uLWNvbnRyb2wgc3lzdGVtIGRhdGEsIG9yIGZyb20gdGhl
IHBhcmVudCBkaXJlY3RvcnkgbmFtZSBvZiBhbgojIHVucGFja2VkIHNvdXJj
ZSBhcmNoaXZlLiBEaXN0cmlidXRpb24gdGFyYmFsbHMgY29udGFpbiBhIHBy
ZS1nZW5lcmF0ZWQgY29weQojIG9mIHRoaXMgZmlsZS4KCmltcG9ydCBqc29u
Cgp2ZXJzaW9uX2pzb24gPSAnJycKJXMKJycnICAjIEVORCBWRVJTSU9OX0pT
T04KCgpkZWYgZ2V0X3ZlcnNpb25zKCk6CiAgICByZXR1cm4ganNvbi5sb2Fk
cyh2ZXJzaW9uX2pzb24pCiIiIgoKCmRlZiB2ZXJzaW9uc19mcm9tX2ZpbGUo
ZmlsZW5hbWUpOgogICAgIiIiVHJ5IHRvIGRldGVybWluZSB0aGUgdmVyc2lv
biBmcm9tIF92ZXJzaW9uLnB5IGlmIHByZXNlbnQuIiIiCiAgICB0cnk6CiAg
ICAgICAgd2l0aCBvcGVuKGZpbGVuYW1lKSBhcyBmOgogICAgICAgICAgICBj
b250ZW50cyA9IGYucmVhZCgpCiAgICBleGNlcHQgRW52aXJvbm1lbnRFcnJv
cjoKICAgICAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCJ1bmFibGUgdG8gcmVh
ZCBfdmVyc2lvbi5weSIpCiAgICBtbyA9IHJlLnNlYXJjaChyInZlcnNpb25f
anNvbiA9ICcnJ1xuKC4qKScnJyAgIyBFTkQgVkVSU0lPTl9KU09OIiwKICAg
ICAgICAgICAgICAgICAgIGNvbnRlbnRzLCByZS5NIHwgcmUuUykKICAgIGlm
IG5vdCBtbzoKICAgICAgICBtbyA9IHJlLnNlYXJjaChyInZlcnNpb25fanNv
biA9ICcnJ1xyXG4oLiopJycnICAjIEVORCBWRVJTSU9OX0pTT04iLAogICAg
ICAgICAgICAgICAgICAgICAgIGNvbnRlbnRzLCByZS5NIHwgcmUuUykKICAg
IGlmIG5vdCBtbzoKICAgICAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCJubyB2
ZXJzaW9uX2pzb24gaW4gX3ZlcnNpb24ucHkiKQogICAgcmV0dXJuIGpzb24u
bG9hZHMobW8uZ3JvdXAoMSkpCgoKZGVmIHdyaXRlX3RvX3ZlcnNpb25fZmls
ZShmaWxlbmFtZSwgdmVyc2lvbnMpOgogICAgIiIiV3JpdGUgdGhlIGdpdmVu
IHZlcnNpb24gbnVtYmVyIHRvIHRoZSBnaXZlbiBfdmVyc2lvbi5weSBmaWxl
LiIiIgogICAgb3MudW5saW5rKGZpbGVuYW1lKQogICAgY29udGVudHMgPSBq
c29uLmR1bXBzKHZlcnNpb25zLCBzb3J0X2tleXM9VHJ1ZSwKICAgICAgICAg
ICAgICAgICAgICAgICAgICBpbmRlbnQ9MSwgc2VwYXJhdG9ycz0oIiwiLCAi
OiAiKSkKICAgIHdpdGggb3BlbihmaWxlbmFtZSwgInciKSBhcyBmOgogICAg
ICAgIGYud3JpdGUoU0hPUlRfVkVSU0lPTl9QWSAlIGNvbnRlbnRzKQoKICAg
IHByaW50KCJzZXQgJXMgdG8gJyVzJyIgJSAoZmlsZW5hbWUsIHZlcnNpb25z
WyJ2ZXJzaW9uIl0pKQoKCmRlZiBwbHVzX29yX2RvdChwaWVjZXMpOgogICAg
IiIiUmV0dXJuIGEgKyBpZiB3ZSBkb24ndCBhbHJlYWR5IGhhdmUgb25lLCBl
bHNlIHJldHVybiBhIC4iIiIKICAgIGlmICIrIiBpbiBwaWVjZXMuZ2V0KCJj
bG9zZXN0LXRhZyIsICIiKToKICAgICAgICByZXR1cm4gIi4iCiAgICByZXR1
cm4gIisiCgoKZGVmIHJlbmRlcl9wZXA0NDAocGllY2VzKToKICAgICIiIkJ1
aWxkIHVwIHZlcnNpb24gc3RyaW5nLCB3aXRoIHBvc3QtcmVsZWFzZSAibG9j
YWwgdmVyc2lvbiBpZGVudGlmaWVyIi4KCiAgICBPdXIgZ29hbDogVEFHWytE
SVNUQU5DRS5nSEVYWy5kaXJ0eV1dIC4gTm90ZSB0aGF0IGlmIHlvdQogICAg
Z2V0IGEgdGFnZ2VkIGJ1aWxkIGFuZCB0aGVuIGRpcnR5IGl0LCB5b3UnbGwg
Z2V0IFRBRyswLmdIRVguZGlydHkKCiAgICBFeGNlcHRpb25zOgogICAgMTog
bm8gdGFncy4gZ2l0X2Rlc2NyaWJlIHdhcyBqdXN0IEhFWC4gMCt1bnRhZ2dl
ZC5ESVNUQU5DRS5nSEVYWy5kaXJ0eV0KICAgICIiIgogICAgaWYgcGllY2Vz
WyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0gcGllY2VzWyJj
bG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5jZSJdIG9y
IHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gcGx1
c19vcl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCArPSAiJWQu
ZyVzIiAlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkK
ICAgICAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAgIGVsc2U6CiAgICAgICAgIyBl
eGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwK3VudGFnZ2VkLiVk
LmclcyIgJSAocGllY2VzWyJkaXN0YW5jZSJdLAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICBwaWVjZXNbInNob3J0Il0pCiAg
ICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJl
ZCArPSAiLmRpcnR5IgogICAgcmV0dXJuIHJlbmRlcmVkCgoKZGVmIHJlbmRl
cl9wZXA0NDBfcHJlKHBpZWNlcyk6CiAgICAiIiJUQUdbLnBvc3QuZGV2RElT
VEFOQ0VdIC0tIE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRpb25zOgogICAgMTog
bm8gdGFncy4gMC5wb3N0LmRldkRJU1RBTkNFCiAgICAiIiIKICAgIGlmIHBp
ZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBpZWNl
c1siY2xvc2VzdC10YWciXQogICAgICAgIGlmIHBpZWNlc1siZGlzdGFuY2Ui
XToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5wb3N0LmRldiVkIiAlIHBp
ZWNlc1siZGlzdGFuY2UiXQogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlv
biAjMQogICAgICAgIHJlbmRlcmVkID0gIjAucG9zdC5kZXYlZCIgJSBwaWVj
ZXNbImRpc3RhbmNlIl0KICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5k
ZXJfcGVwNDQwX3Bvc3QocGllY2VzKToKICAgICIiIlRBR1sucG9zdERJU1RB
TkNFWy5kZXYwXStnSEVYXSAuCgogICAgVGhlICIuZGV2MCIgbWVhbnMgZGly
dHkuIE5vdGUgdGhhdCAuZGV2MCBzb3J0cyBiYWNrd2FyZHMKICAgIChhIGRp
cnR5IHRyZWUgd2lsbCBhcHBlYXIgIm9sZGVyIiB0aGFuIHRoZSBjb3JyZXNw
b25kaW5nIGNsZWFuIG9uZSksCiAgICBidXQgeW91IHNob3VsZG4ndCBiZSBy
ZWxlYXNpbmcgc29mdHdhcmUgd2l0aCAtZGlydHkgYW55d2F5cy4KCiAgICBF
eGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gMC5wb3N0RElTVEFOQ0VbLmRl
djBdCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWciXToKICAg
ICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQogICAgICAg
IGlmIHBpZWNlc1siZGlzdGFuY2UiXSBvciBwaWVjZXNbImRpcnR5Il06CiAg
ICAgICAgICAgIHJlbmRlcmVkICs9ICIucG9zdCVkIiAlIHBpZWNlc1siZGlz
dGFuY2UiXQogICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAg
ICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICAgICAgICAgIHJl
bmRlcmVkICs9IHBsdXNfb3JfZG90KHBpZWNlcykKICAgICAgICAgICAgcmVu
ZGVyZWQgKz0gImclcyIgJSBwaWVjZXNbInNob3J0Il0KICAgIGVsc2U6CiAg
ICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwLnBv
c3QlZCIgJSBwaWVjZXNbImRpc3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNb
ImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAg
ICAgICByZW5kZXJlZCArPSAiK2clcyIgJSBwaWVjZXNbInNob3J0Il0KICAg
IHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfcGVwNDQwX29sZChwaWVj
ZXMpOgogICAgIiIiVEFHWy5wb3N0RElTVEFOQ0VbLmRldjBdXSAuCgogICAg
VGhlICIuZGV2MCIgbWVhbnMgZGlydHkuCgogICAgRWV4Y2VwdGlvbnM6CiAg
ICAxOiBubyB0YWdzLiAwLnBvc3RESVNUQU5DRVsuZGV2MF0KICAgICIiIgog
ICAgaWYgcGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVk
ID0gcGllY2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJk
aXN0YW5jZSJdIG9yIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVu
ZGVyZWQgKz0gIi5wb3N0JWQiICUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICAg
ICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgICAgIHJl
bmRlcmVkICs9ICIuZGV2MCIKICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRp
b24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwLnBvc3QlZCIgJSBwaWVjZXNb
ImRpc3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAg
ICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgIHJldHVybiByZW5kZXJl
ZAoKCmRlZiByZW5kZXJfcGVwNDQwX2luYyhwaWVjZXMpOgogICAgIiIiQnVp
bGQgdXAgdmVyc2lvbiBzdHJpbmcsIGluY3JlbWVudGluZyB0aGUgcGF0Y2gg
ZmllbGQsIgoKICAgIE91ciBnb2FsOiBNQVlPUi5NSU5PUi4oUEFUSENIKzEp
LiBOb3RlIHRoYXQgaWYgeW91CiAgICBnZXQgYSB0YWdnZWQgYnVpbGQgYW5k
IHRoZW4gZGlydHkgaXQsIHlvdSdsbCBnZXQgVEFHKzAuZ0hFWC5kaXJ0eQoK
ICAgIEV4Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiBnaXRfZGVzY3JpYmUg
d2FzIGp1c3QgSEVYLiAwK3VudGFnZ2VkLkRJU1RBTkNFLmdIRVhbLmRpcnR5
XQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAg
ICAgc3BsaXR0ZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0uc3BsaXQoJy4n
KQogICAgICAgIHBhdGNoID0gaW50KHNwbGl0dGVkWy0xXSkKCiAgICAgICAg
aWYgcGllY2VzWyJkaXN0YW5jZSJdOgogICAgICAgICAgICBwYXRjaCArPSBw
aWVjZXNbImRpc3RhbmNlIl0KCiAgICAgICAgcmVuZGVyZWQgPSAnLicuam9p
bihzcGxpdHRlZFswOmxlbihzcGxpdHRlZCktMV0pICsgJy4nICsgc3RyKHBh
dGNoKQoKICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAg
IHJlbmRlcmVkICs9ICIuZGlydHkiCiAgICBlbHNlOgogICAgICAgICMgZXhj
ZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMCt1bnRhZ2dlZC4lZC5n
JXMiICUgKHBpZWNlc1siZGlzdGFuY2UiXSwKICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgcGllY2VzWyJzaG9ydCJdKQogICAg
ICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQg
Kz0gIi5kaXJ0eSIKICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJf
Z2l0X2Rlc2NyaWJlKHBpZWNlcyk6CiAgICAiIiJUQUdbLURJU1RBTkNFLWdI
RVhdWy1kaXJ0eV0uCgogICAgTGlrZSAnZ2l0IGRlc2NyaWJlIC0tdGFncyAt
LWRpcnR5IC0tYWx3YXlzJy4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8g
dGFncy4gSEVYWy1kaXJ0eV0gIChub3RlOiBubyAnZycgcHJlZml4KQogICAg
IiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVu
ZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVj
ZXNbImRpc3RhbmNlIl06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICItJWQt
ZyVzIiAlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkK
ICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5k
ZXJlZCA9IHBpZWNlc1sic2hvcnQiXQogICAgaWYgcGllY2VzWyJkaXJ0eSJd
OgogICAgICAgIHJlbmRlcmVkICs9ICItZGlydHkiCiAgICByZXR1cm4gcmVu
ZGVyZWQKCgpkZWYgcmVuZGVyX2dpdF9kZXNjcmliZV9sb25nKHBpZWNlcyk6
CiAgICAiIiJUQUctRElTVEFOQ0UtZ0hFWFstZGlydHldLgoKICAgIExpa2Ug
J2dpdCBkZXNjcmliZSAtLXRhZ3MgLS1kaXJ0eSAtLWFsd2F5cyAtbG9uZycu
CiAgICBUaGUgZGlzdGFuY2UvaGFzaCBpcyB1bmNvbmRpdGlvbmFsLgoKICAg
IEV4Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiBIRVhbLWRpcnR5XSAgKG5v
dGU6IG5vICdnJyBwcmVmaXgpCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xv
c2VzdC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2Vz
dC10YWciXQogICAgICAgIHJlbmRlcmVkICs9ICItJWQtZyVzIiAlIChwaWVj
ZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkKICAgIGVsc2U6CiAg
ICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9IHBpZWNl
c1sic2hvcnQiXQogICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgIHJl
bmRlcmVkICs9ICItZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYg
cmVuZGVyKHBpZWNlcywgc3R5bGUpOgogICAgIiIiUmVuZGVyIHRoZSBnaXZl
biB2ZXJzaW9uIHBpZWNlcyBpbnRvIHRoZSByZXF1ZXN0ZWQgc3R5bGUuIiIi
CiAgICBpZiBwaWVjZXNbImVycm9yIl06CiAgICAgICAgcmV0dXJuIHsidmVy
c2lvbiI6ICJ1bmtub3duIiwKICAgICAgICAgICAgICAgICJmdWxsLXJldmlz
aW9uaWQiOiBwaWVjZXMuZ2V0KCJsb25nIiksCiAgICAgICAgICAgICAgICAi
ZGlydHkiOiBOb25lLAogICAgICAgICAgICAgICAgImVycm9yIjogcGllY2Vz
WyJlcnJvciJdLAogICAgICAgICAgICAgICAgImRhdGUiOiBOb25lfQoKICAg
IGlmIG5vdCBzdHlsZSBvciBzdHlsZSA9PSAiZGVmYXVsdCI6CiAgICAgICAg
c3R5bGUgPSAicGVwNDQwIiAgIyB0aGUgZGVmYXVsdAoKICAgIGlmIHN0eWxl
ID09ICJwZXA0NDAiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0
MChwaWVjZXMpCiAgICBlbGlmIHN0eWxlID09ICJwZXA0NDAtcHJlIjoKICAg
ICAgICByZW5kZXJlZCA9IHJlbmRlcl9wZXA0NDBfcHJlKHBpZWNlcykKICAg
IGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1wb3N0IjoKICAgICAgICByZW5kZXJl
ZCA9IHJlbmRlcl9wZXA0NDBfcG9zdChwaWVjZXMpCiAgICBlbGlmIHN0eWxl
ID09ICJwZXA0NDAtb2xkIjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRlcl9w
ZXA0NDBfb2xkKHBpZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1p
bmMiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9pbmMocGll
Y2VzKQogICAgZWxpZiBzdHlsZSA9PSAiZ2l0LWRlc2NyaWJlIjoKICAgICAg
ICByZW5kZXJlZCA9IHJlbmRlcl9naXRfZGVzY3JpYmUocGllY2VzKQogICAg
ZWxpZiBzdHlsZSA9PSAiZ2l0LWRlc2NyaWJlLWxvbmciOgogICAgICAgIHJl
bmRlcmVkID0gcmVuZGVyX2dpdF9kZXNjcmliZV9sb25nKHBpZWNlcykKICAg
IGVsc2U6CiAgICAgICAgcmFpc2UgVmFsdWVFcnJvcigidW5rbm93biBzdHls
ZSAnJXMnIiAlIHN0eWxlKQoKICAgIHJldHVybiB7InZlcnNpb24iOiByZW5k
ZXJlZCwgImZ1bGwtcmV2aXNpb25pZCI6IHBpZWNlc1sibG9uZyJdLAogICAg
ICAgICAgICAiZGlydHkiOiBwaWVjZXNbImRpcnR5Il0sICJlcnJvciI6IE5v
bmUsCiAgICAgICAgICAgICJkYXRlIjogcGllY2VzLmdldCgiZGF0ZSIpfQoK
Y2xhc3MgVmVyc2lvbmVlckJhZFJvb3RFcnJvcihFeGNlcHRpb24pOgogICAg
IiIiVGhlIHByb2plY3Qgcm9vdCBkaXJlY3RvcnkgaXMgdW5rbm93biBvciBt
aXNzaW5nIGtleSBmaWxlcy4iIiIKCgpkZWYgZ2V0X3ZlcnNpb25zKHZlcmJv
c2U9RmFsc2UpOgogICAgIiIiR2V0IHRoZSBwcm9qZWN0IHZlcnNpb24gZnJv
bSB3aGF0ZXZlciBzb3VyY2UgaXMgYXZhaWxhYmxlLgoKICAgIFJldHVybnMg
ZGljdCB3aXRoIHR3byBrZXlzOiAndmVyc2lvbicgYW5kICdmdWxsJy4KICAg
ICIiIgogICAgaWYgInZlcnNpb25lZXIiIGluIHN5cy5tb2R1bGVzOgogICAg
ICAgICMgc2VlIHRoZSBkaXNjdXNzaW9uIGluIGNtZGNsYXNzLnB5OmdldF9j
bWRjbGFzcygpCiAgICAgICAgZGVsIHN5cy5tb2R1bGVzWyJ2ZXJzaW9uZWVy
Il0KCiAgICByb290ID0gZ2V0X3Jvb3QoKQogICAgY2ZnID0gZ2V0X2NvbmZp
Z19mcm9tX3Jvb3Qocm9vdCkKCiAgICBhc3NlcnQgY2ZnLlZDUyBpcyBub3Qg
Tm9uZSwgInBsZWFzZSBzZXQgW3ZlcnNpb25lZXJdVkNTPSBpbiBzZXR1cC5j
ZmciCiAgICBoYW5kbGVycyA9IEhBTkRMRVJTLmdldChjZmcuVkNTKQogICAg
YXNzZXJ0IGhhbmRsZXJzLCAidW5yZWNvZ25pemVkIFZDUyAnJXMnIiAlIGNm
Zy5WQ1MKICAgIHZlcmJvc2UgPSB2ZXJib3NlIG9yIGNmZy52ZXJib3NlCiAg
ICBhc3NlcnQgY2ZnLnZlcnNpb25maWxlX3NvdXJjZSBpcyBub3QgTm9uZSwg
XAogICAgICAgICJwbGVhc2Ugc2V0IHZlcnNpb25lZXIudmVyc2lvbmZpbGVf
c291cmNlIgogICAgYXNzZXJ0IGNmZy50YWdfcHJlZml4IGlzIG5vdCBOb25l
LCAicGxlYXNlIHNldCB2ZXJzaW9uZWVyLnRhZ19wcmVmaXgiCgogICAgdmVy
c2lvbmZpbGVfYWJzID0gb3MucGF0aC5qb2luKHJvb3QsIGNmZy52ZXJzaW9u
ZmlsZV9zb3VyY2UpCgogICAgIyBleHRyYWN0IHZlcnNpb24gZnJvbSBmaXJz
dCBvZjogX3ZlcnNpb24ucHksIFZDUyBjb21tYW5kIChlLmcuICdnaXQKICAg
ICMgZGVzY3JpYmUnKSwgcGFyZW50ZGlyLiBUaGlzIGlzIG1lYW50IHRvIHdv
cmsgZm9yIGRldmVsb3BlcnMgdXNpbmcgYQogICAgIyBzb3VyY2UgY2hlY2tv
dXQsIGZvciB1c2VycyBvZiBhIHRhcmJhbGwgY3JlYXRlZCBieSAnc2V0dXAu
cHkgc2Rpc3QnLAogICAgIyBhbmQgZm9yIHVzZXJzIG9mIGEgdGFyYmFsbC96
aXBiYWxsIGNyZWF0ZWQgYnkgJ2dpdCBhcmNoaXZlJyBvciBnaXRodWIncwog
ICAgIyBkb3dubG9hZC1mcm9tLXRhZyBmZWF0dXJlIG9yIHRoZSBlcXVpdmFs
ZW50IGluIG90aGVyIFZDU2VzLgoKICAgIGdldF9rZXl3b3Jkc19mID0gaGFu
ZGxlcnMuZ2V0KCJnZXRfa2V5d29yZHMiKQogICAgZnJvbV9rZXl3b3Jkc19m
ID0gaGFuZGxlcnMuZ2V0KCJrZXl3b3JkcyIpCiAgICBpZiBnZXRfa2V5d29y
ZHNfZiBhbmQgZnJvbV9rZXl3b3Jkc19mOgogICAgICAgIHRyeToKICAgICAg
ICAgICAga2V5d29yZHMgPSBnZXRfa2V5d29yZHNfZih2ZXJzaW9uZmlsZV9h
YnMpCiAgICAgICAgICAgIHZlciA9IGZyb21fa2V5d29yZHNfZihrZXl3b3Jk
cywgY2ZnLnRhZ19wcmVmaXgsIHZlcmJvc2UpCiAgICAgICAgICAgIGlmIHZl
cmJvc2U6CiAgICAgICAgICAgICAgICBwcmludCgiZ290IHZlcnNpb24gZnJv
bSBleHBhbmRlZCBrZXl3b3JkICVzIiAlIHZlcikKICAgICAgICAgICAgcmV0
dXJuIHZlcgogICAgICAgIGV4Y2VwdCBOb3RUaGlzTWV0aG9kOgogICAgICAg
ICAgICBwYXNzCgogICAgdHJ5OgogICAgICAgIHZlciA9IHZlcnNpb25zX2Zy
b21fZmlsZSh2ZXJzaW9uZmlsZV9hYnMpCiAgICAgICAgaWYgdmVyYm9zZToK
ICAgICAgICAgICAgcHJpbnQoImdvdCB2ZXJzaW9uIGZyb20gZmlsZSAlcyAl
cyIgJSAodmVyc2lvbmZpbGVfYWJzLCB2ZXIpKQogICAgICAgIHJldHVybiB2
ZXIKICAgIGV4Y2VwdCBOb3RUaGlzTWV0aG9kOgogICAgICAgIHBhc3MKCiAg
ICBmcm9tX3Zjc19mID0gaGFuZGxlcnMuZ2V0KCJwaWVjZXNfZnJvbV92Y3Mi
KQogICAgaWYgZnJvbV92Y3NfZjoKICAgICAgICB0cnk6CiAgICAgICAgICAg
IHBpZWNlcyA9IGZyb21fdmNzX2YoY2ZnLnRhZ19wcmVmaXgsIHJvb3QsIHZl
cmJvc2UpCiAgICAgICAgICAgIHZlciA9IHJlbmRlcihwaWVjZXMsIGNmZy5z
dHlsZSkKICAgICAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgICAg
IHByaW50KCJnb3QgdmVyc2lvbiBmcm9tIFZDUyAlcyIgJSB2ZXIpCiAgICAg
ICAgICAgIHJldHVybiB2ZXIKICAgICAgICBleGNlcHQgTm90VGhpc01ldGhv
ZDoKICAgICAgICAgICAgcGFzcwoKICAgIHRyeToKICAgICAgICBpZiBjZmcu
cGFyZW50ZGlyX3ByZWZpeDoKICAgICAgICAgICAgdmVyID0gdmVyc2lvbnNf
ZnJvbV9wYXJlbnRkaXIoY2ZnLnBhcmVudGRpcl9wcmVmaXgsIHJvb3QsIHZl
cmJvc2UpCiAgICAgICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAgICAg
ICBwcmludCgiZ290IHZlcnNpb24gZnJvbSBwYXJlbnRkaXIgJXMiICUgdmVy
KQogICAgICAgICAgICByZXR1cm4gdmVyCiAgICBleGNlcHQgTm90VGhpc01l
dGhvZDoKICAgICAgICBwYXNzCgogICAgaWYgdmVyYm9zZToKICAgICAgICBw
cmludCgidW5hYmxlIHRvIGNvbXB1dGUgdmVyc2lvbiIpCgogICAgcmV0dXJu
IHsidmVyc2lvbiI6ICIwK3Vua25vd24iLCAiZnVsbC1yZXZpc2lvbmlkIjog
Tm9uZSwKICAgICAgICAgICAgImRpcnR5IjogTm9uZSwgImVycm9yIjogInVu
YWJsZSB0byBjb21wdXRlIHZlcnNpb24iLAogICAgICAgICAgICAiZGF0ZSI6
IE5vbmV9CgoKZGVmIGdldF92ZXJzaW9uKCk6CiAgICAiIiJHZXQgdGhlIHNo
b3J0IHZlcnNpb24gc3RyaW5nIGZvciB0aGlzIHByb2plY3QuIiIiCiAgICBy
ZXR1cm4gZ2V0X3ZlcnNpb25zKClbInZlcnNpb24iXQoKCmRlZiBnZXRfY21k
Y2xhc3MoKToKICAgICIiIkdldCB0aGUgY3VzdG9tIHNldHVwdG9vbHMvZGlz
dHV0aWxzIHN1YmNsYXNzZXMgdXNlZCBieSBWZXJzaW9uZWVyLiIiIgogICAg
aWYgInZlcnNpb25lZXIiIGluIHN5cy5tb2R1bGVzOgogICAgICAgIGRlbCBz
eXMubW9kdWxlc1sidmVyc2lvbmVlciJdCiAgICAgICAgIyB0aGlzIGZpeGVz
IHRoZSAicHl0aG9uIHNldHVwLnB5IGRldmVsb3AiIGNhc2UgKGFsc28gJ2lu
c3RhbGwnIGFuZAogICAgICAgICMgJ2Vhc3lfaW5zdGFsbCAuJyksIGluIHdo
aWNoIHN1YmRlcGVuZGVuY2llcyBvZiB0aGUgbWFpbiBwcm9qZWN0IGFyZQog
ICAgICAgICMgYnVpbHQgKHVzaW5nIHNldHVwLnB5IGJkaXN0X2VnZykgaW4g
dGhlIHNhbWUgcHl0aG9uIHByb2Nlc3MuIEFzc3VtZQogICAgICAgICMgYSBt
YWluIHByb2plY3QgQSBhbmQgYSBkZXBlbmRlbmN5IEIsIHdoaWNoIHVzZSBk
aWZmZXJlbnQgdmVyc2lvbnMKICAgICAgICAjIG9mIFZlcnNpb25lZXIuIEEn
cyBzZXR1cC5weSBpbXBvcnRzIEEncyBWZXJzaW9uZWVyLCBsZWF2aW5nIGl0
IGluCiAgICAgICAgIyBzeXMubW9kdWxlcyBieSB0aGUgdGltZSBCJ3Mgc2V0
dXAucHkgaXMgZXhlY3V0ZWQsIGNhdXNpbmcgQiB0byBydW4KICAgICAgICAj
IHdpdGggdGhlIHdyb25nIHZlcnNpb25lZXIuIFNldHVwdG9vbHMgd3JhcHMg
dGhlIHN1Yi1kZXAgYnVpbGRzIGluIGEKICAgICAgICAjIHNhbmRib3ggdGhh
dCByZXN0b3JlcyBzeXMubW9kdWxlcyB0byBpdCdzIHByZS1idWlsZCBzdGF0
ZSwgc28gdGhlCiAgICAgICAgIyBwYXJlbnQgaXMgcHJvdGVjdGVkIGFnYWlu
c3QgdGhlIGNoaWxkJ3MgImltcG9ydCB2ZXJzaW9uZWVyIi4gQnkKICAgICAg
ICAjIHJlbW92aW5nIG91cnNlbHZlcyBmcm9tIHN5cy5tb2R1bGVzIGhlcmUs
IGJlZm9yZSB0aGUgY2hpbGQgYnVpbGQKICAgICAgICAjIGhhcHBlbnMsIHdl
IHByb3RlY3QgdGhlIGNoaWxkIGZyb20gdGhlIHBhcmVudCdzIHZlcnNpb25l
ZXIgdG9vLgogICAgICAgICMgQWxzbyBzZWUgaHR0cHM6Ly9naXRodWIuY29t
L3dhcm5lci9weXRob24tdmVyc2lvbmVlci9pc3N1ZXMvNTIKCiAgICBjbWRz
ID0ge30KCiAgICAjIHdlIGFkZCAidmVyc2lvbiIgdG8gYm90aCBkaXN0dXRp
bHMgYW5kIHNldHVwdG9vbHMKICAgIGZyb20gZGlzdHV0aWxzLmNvcmUgaW1w
b3J0IENvbW1hbmQKCiAgICBjbGFzcyBjbWRfdmVyc2lvbihDb21tYW5kKToK
ICAgICAgICBkZXNjcmlwdGlvbiA9ICJyZXBvcnQgZ2VuZXJhdGVkIHZlcnNp
b24gc3RyaW5nIgogICAgICAgIHVzZXJfb3B0aW9ucyA9IFtdCiAgICAgICAg
Ym9vbGVhbl9vcHRpb25zID0gW10KCiAgICAgICAgZGVmIGluaXRpYWxpemVf
b3B0aW9ucyhzZWxmKToKICAgICAgICAgICAgcGFzcwoKICAgICAgICBkZWYg
ZmluYWxpemVfb3B0aW9ucyhzZWxmKToKICAgICAgICAgICAgcGFzcwoKICAg
ICAgICBkZWYgcnVuKHNlbGYpOgogICAgICAgICAgICB2ZXJzID0gZ2V0X3Zl
cnNpb25zKHZlcmJvc2U9VHJ1ZSkKICAgICAgICAgICAgcHJpbnQoIlZlcnNp
b246ICVzIiAlIHZlcnNbInZlcnNpb24iXSkKICAgICAgICAgICAgcHJpbnQo
IiBmdWxsLXJldmlzaW9uaWQ6ICVzIiAlIHZlcnMuZ2V0KCJmdWxsLXJldmlz
aW9uaWQiKSkKICAgICAgICAgICAgcHJpbnQoIiBkaXJ0eTogJXMiICUgdmVy
cy5nZXQoImRpcnR5IikpCiAgICAgICAgICAgIHByaW50KCIgZGF0ZTogJXMi
ICUgdmVycy5nZXQoImRhdGUiKSkKICAgICAgICAgICAgaWYgdmVyc1siZXJy
b3IiXToKICAgICAgICAgICAgICAgIHByaW50KCIgZXJyb3I6ICVzIiAlIHZl
cnNbImVycm9yIl0pCiAgICBjbWRzWyJ2ZXJzaW9uIl0gPSBjbWRfdmVyc2lv
bgoKICAgICMgd2Ugb3ZlcnJpZGUgImJ1aWxkX3B5IiBpbiBib3RoIGRpc3R1
dGlscyBhbmQgc2V0dXB0b29scwogICAgIwogICAgIyBtb3N0IGludm9jYXRp
b24gcGF0aHdheXMgZW5kIHVwIHJ1bm5pbmcgYnVpbGRfcHk6CiAgICAjICBk
aXN0dXRpbHMvYnVpbGQgLT4gYnVpbGRfcHkKICAgICMgIGRpc3R1dGlscy9p
bnN0YWxsIC0+IGRpc3R1dGlscy9idWlsZCAtPi4uCiAgICAjICBzZXR1cHRv
b2xzL2JkaXN0X3doZWVsIC0+IGRpc3R1dGlscy9pbnN0YWxsIC0+Li4KICAg
ICMgIHNldHVwdG9vbHMvYmRpc3RfZWdnIC0+IGRpc3R1dGlscy9pbnN0YWxs
X2xpYiAtPiBidWlsZF9weQogICAgIyAgc2V0dXB0b29scy9pbnN0YWxsIC0+
IGJkaXN0X2VnZyAtPi4uCiAgICAjICBzZXR1cHRvb2xzL2RldmVsb3AgLT4g
PwogICAgIyAgcGlwIGluc3RhbGw6CiAgICAjICAgY29waWVzIHNvdXJjZSB0
cmVlIHRvIGEgdGVtcGRpciBiZWZvcmUgcnVubmluZyBlZ2dfaW5mby9ldGMK
ICAgICMgICBpZiAuZ2l0IGlzbid0IGNvcGllZCB0b28sICdnaXQgZGVzY3Jp
YmUnIHdpbGwgZmFpbAogICAgIyAgIHRoZW4gZG9lcyBzZXR1cC5weSBiZGlz
dF93aGVlbCwgb3Igc29tZXRpbWVzIHNldHVwLnB5IGluc3RhbGwKICAgICMg
IHNldHVwLnB5IGVnZ19pbmZvIC0+ID8KCiAgICAjIHdlIG92ZXJyaWRlIGRp
ZmZlcmVudCAiYnVpbGRfcHkiIGNvbW1hbmRzIGZvciBib3RoIGVudmlyb25t
ZW50cwogICAgaWYgInNldHVwdG9vbHMiIGluIHN5cy5tb2R1bGVzOgogICAg
ICAgIGZyb20gc2V0dXB0b29scy5jb21tYW5kLmJ1aWxkX3B5IGltcG9ydCBi
dWlsZF9weSBhcyBfYnVpbGRfcHkKICAgIGVsc2U6CiAgICAgICAgZnJvbSBk
aXN0dXRpbHMuY29tbWFuZC5idWlsZF9weSBpbXBvcnQgYnVpbGRfcHkgYXMg
X2J1aWxkX3B5CgogICAgY2xhc3MgY21kX2J1aWxkX3B5KF9idWlsZF9weSk6
CiAgICAgICAgZGVmIHJ1bihzZWxmKToKICAgICAgICAgICAgcm9vdCA9IGdl
dF9yb290KCkKICAgICAgICAgICAgY2ZnID0gZ2V0X2NvbmZpZ19mcm9tX3Jv
b3Qocm9vdCkKICAgICAgICAgICAgdmVyc2lvbnMgPSBnZXRfdmVyc2lvbnMo
KQogICAgICAgICAgICBfYnVpbGRfcHkucnVuKHNlbGYpCiAgICAgICAgICAg
ICMgbm93IGxvY2F0ZSBfdmVyc2lvbi5weSBpbiB0aGUgbmV3IGJ1aWxkLyBk
aXJlY3RvcnkgYW5kIHJlcGxhY2UKICAgICAgICAgICAgIyBpdCB3aXRoIGFu
IHVwZGF0ZWQgdmFsdWUKICAgICAgICAgICAgaWYgY2ZnLnZlcnNpb25maWxl
X2J1aWxkOgogICAgICAgICAgICAgICAgdGFyZ2V0X3ZlcnNpb25maWxlID0g
b3MucGF0aC5qb2luKHNlbGYuYnVpbGRfbGliLAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIGNmZy52ZXJzaW9u
ZmlsZV9idWlsZCkKICAgICAgICAgICAgICAgIHByaW50KCJVUERBVElORyAl
cyIgJSB0YXJnZXRfdmVyc2lvbmZpbGUpCiAgICAgICAgICAgICAgICB3cml0
ZV90b192ZXJzaW9uX2ZpbGUodGFyZ2V0X3ZlcnNpb25maWxlLCB2ZXJzaW9u
cykKICAgIGNtZHNbImJ1aWxkX3B5Il0gPSBjbWRfYnVpbGRfcHkKCiAgICBp
ZiAiY3hfRnJlZXplIiBpbiBzeXMubW9kdWxlczogICMgY3hfZnJlZXplIGVu
YWJsZWQ/CiAgICAgICAgZnJvbSBjeF9GcmVlemUuZGlzdCBpbXBvcnQgYnVp
bGRfZXhlIGFzIF9idWlsZF9leGUKICAgICAgICAjIG5jemVjenVsaW4gcmVw
b3J0cyB0aGF0IHB5MmV4ZSB3b24ndCBsaWtlIHRoZSBwZXA0NDAtc3R5bGUg
c3RyaW5nCiAgICAgICAgIyBhcyBGSUxFVkVSU0lPTiwgYnV0IGl0IGNhbiBi
ZSB1c2VkIGZvciBQUk9EVUNUVkVSU0lPTiwgZS5nLgogICAgICAgICMgc2V0
dXAoY29uc29sZT1bewogICAgICAgICMgICAidmVyc2lvbiI6IHZlcnNpb25l
ZXIuZ2V0X3ZlcnNpb24oKS5zcGxpdCgiKyIsIDEpWzBdLCAjIEZJTEVWRVJT
SU9OCiAgICAgICAgIyAgICJwcm9kdWN0X3ZlcnNpb24iOiB2ZXJzaW9uZWVy
LmdldF92ZXJzaW9uKCksCiAgICAgICAgIyAgIC4uLgoKICAgICAgICBjbGFz
cyBjbWRfYnVpbGRfZXhlKF9idWlsZF9leGUpOgogICAgICAgICAgICBkZWYg
cnVuKHNlbGYpOgogICAgICAgICAgICAgICAgcm9vdCA9IGdldF9yb290KCkK
ICAgICAgICAgICAgICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290KHJv
b3QpCiAgICAgICAgICAgICAgICB2ZXJzaW9ucyA9IGdldF92ZXJzaW9ucygp
CiAgICAgICAgICAgICAgICB0YXJnZXRfdmVyc2lvbmZpbGUgPSBjZmcudmVy
c2lvbmZpbGVfc291cmNlCiAgICAgICAgICAgICAgICBwcmludCgiVVBEQVRJ
TkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25maWxlKQogICAgICAgICAgICAgICAg
d3JpdGVfdG9fdmVyc2lvbl9maWxlKHRhcmdldF92ZXJzaW9uZmlsZSwgdmVy
c2lvbnMpCgogICAgICAgICAgICAgICAgX2J1aWxkX2V4ZS5ydW4oc2VsZikK
ICAgICAgICAgICAgICAgIG9zLnVubGluayh0YXJnZXRfdmVyc2lvbmZpbGUp
CiAgICAgICAgICAgICAgICB3aXRoIG9wZW4oY2ZnLnZlcnNpb25maWxlX3Nv
dXJjZSwgInciKSBhcyBmOgogICAgICAgICAgICAgICAgICAgIExPTkcgPSBM
T05HX1ZFUlNJT05fUFlbY2ZnLlZDU10KICAgICAgICAgICAgICAgICAgICBm
LndyaXRlKExPTkcgJQogICAgICAgICAgICAgICAgICAgICAgICAgICAgeyJE
T0xMQVIiOiAiJCIsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIlNU
WUxFIjogY2ZnLnN0eWxlLAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICJUQUdfUFJFRklYIjogY2ZnLnRhZ19wcmVmaXgsCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgIlBBUkVOVERJUl9QUkVGSVgiOiBjZmcucGFyZW50
ZGlyX3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAiVkVS
U0lPTkZJTEVfU09VUkNFIjogY2ZnLnZlcnNpb25maWxlX3NvdXJjZSwKICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICB9KQogICAgICAgIGNtZHNbImJ1
aWxkX2V4ZSJdID0gY21kX2J1aWxkX2V4ZQogICAgICAgIGRlbCBjbWRzWyJi
dWlsZF9weSJdCgogICAgaWYgJ3B5MmV4ZScgaW4gc3lzLm1vZHVsZXM6ICAj
IHB5MmV4ZSBlbmFibGVkPwogICAgICAgIHRyeToKICAgICAgICAgICAgZnJv
bSBweTJleGUuZGlzdHV0aWxzX2J1aWxkZXhlIGltcG9ydCBweTJleGUgYXMg
X3B5MmV4ZSAgIyBweTMKICAgICAgICBleGNlcHQgSW1wb3J0RXJyb3I6CiAg
ICAgICAgICAgIGZyb20gcHkyZXhlLmJ1aWxkX2V4ZSBpbXBvcnQgcHkyZXhl
IGFzIF9weTJleGUgICMgcHkyCgogICAgICAgIGNsYXNzIGNtZF9weTJleGUo
X3B5MmV4ZSk6CiAgICAgICAgICAgIGRlZiBydW4oc2VsZik6CiAgICAgICAg
ICAgICAgICByb290ID0gZ2V0X3Jvb3QoKQogICAgICAgICAgICAgICAgY2Zn
ID0gZ2V0X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAgICAgICAgICAgICAg
IHZlcnNpb25zID0gZ2V0X3ZlcnNpb25zKCkKICAgICAgICAgICAgICAgIHRh
cmdldF92ZXJzaW9uZmlsZSA9IGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UKICAg
ICAgICAgICAgICAgIHByaW50KCJVUERBVElORyAlcyIgJSB0YXJnZXRfdmVy
c2lvbmZpbGUpCiAgICAgICAgICAgICAgICB3cml0ZV90b192ZXJzaW9uX2Zp
bGUodGFyZ2V0X3ZlcnNpb25maWxlLCB2ZXJzaW9ucykKCiAgICAgICAgICAg
ICAgICBfcHkyZXhlLnJ1bihzZWxmKQogICAgICAgICAgICAgICAgb3MudW5s
aW5rKHRhcmdldF92ZXJzaW9uZmlsZSkKICAgICAgICAgICAgICAgIHdpdGgg
b3BlbihjZmcudmVyc2lvbmZpbGVfc291cmNlLCAidyIpIGFzIGY6CiAgICAg
ICAgICAgICAgICAgICAgTE9ORyA9IExPTkdfVkVSU0lPTl9QWVtjZmcuVkNT
XQogICAgICAgICAgICAgICAgICAgIGYud3JpdGUoTE9ORyAlCiAgICAgICAg
ICAgICAgICAgICAgICAgICAgICB7IkRPTExBUiI6ICIkIiwKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAiU1RZTEUiOiBjZmcuc3R5bGUsCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIlRBR19QUkVGSVgiOiBjZmcudGFn
X3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAiUEFSRU5U
RElSX1BSRUZJWCI6IGNmZy5wYXJlbnRkaXJfcHJlZml4LAogICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICJWRVJTSU9ORklMRV9TT1VSQ0UiOiBjZmcu
dmVyc2lvbmZpbGVfc291cmNlLAogICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIH0pCiAgICAgICAgY21kc1sicHkyZXhlIl0gPSBjbWRfcHkyZXhlCgog
ICAgIyB3ZSBvdmVycmlkZSBkaWZmZXJlbnQgInNkaXN0IiBjb21tYW5kcyBm
b3IgYm90aCBlbnZpcm9ubWVudHMKICAgIGlmICJzZXR1cHRvb2xzIiBpbiBz
eXMubW9kdWxlczoKICAgICAgICBmcm9tIHNldHVwdG9vbHMuY29tbWFuZC5z
ZGlzdCBpbXBvcnQgc2Rpc3QgYXMgX3NkaXN0CiAgICBlbHNlOgogICAgICAg
IGZyb20gZGlzdHV0aWxzLmNvbW1hbmQuc2Rpc3QgaW1wb3J0IHNkaXN0IGFz
IF9zZGlzdAoKICAgIGNsYXNzIGNtZF9zZGlzdChfc2Rpc3QpOgogICAgICAg
IGRlZiBydW4oc2VsZik6CiAgICAgICAgICAgIHZlcnNpb25zID0gZ2V0X3Zl
cnNpb25zKCkKICAgICAgICAgICAgc2VsZi5fdmVyc2lvbmVlcl9nZW5lcmF0
ZWRfdmVyc2lvbnMgPSB2ZXJzaW9ucwogICAgICAgICAgICAjIHVubGVzcyB3
ZSB1cGRhdGUgdGhpcywgdGhlIGNvbW1hbmQgd2lsbCBrZWVwIHVzaW5nIHRo
ZSBvbGQKICAgICAgICAgICAgIyB2ZXJzaW9uCiAgICAgICAgICAgIHNlbGYu
ZGlzdHJpYnV0aW9uLm1ldGFkYXRhLnZlcnNpb24gPSB2ZXJzaW9uc1sidmVy
c2lvbiJdCiAgICAgICAgICAgIHJldHVybiBfc2Rpc3QucnVuKHNlbGYpCgog
ICAgICAgIGRlZiBtYWtlX3JlbGVhc2VfdHJlZShzZWxmLCBiYXNlX2Rpciwg
ZmlsZXMpOgogICAgICAgICAgICByb290ID0gZ2V0X3Jvb3QoKQogICAgICAg
ICAgICBjZmcgPSBnZXRfY29uZmlnX2Zyb21fcm9vdChyb290KQogICAgICAg
ICAgICBfc2Rpc3QubWFrZV9yZWxlYXNlX3RyZWUoc2VsZiwgYmFzZV9kaXIs
IGZpbGVzKQogICAgICAgICAgICAjIG5vdyBsb2NhdGUgX3ZlcnNpb24ucHkg
aW4gdGhlIG5ldyBiYXNlX2RpciBkaXJlY3RvcnkKICAgICAgICAgICAgIyAo
cmVtZW1iZXJpbmcgdGhhdCBpdCBtYXkgYmUgYSBoYXJkbGluaykgYW5kIHJl
cGxhY2UgaXQgd2l0aCBhbgogICAgICAgICAgICAjIHVwZGF0ZWQgdmFsdWUK
ICAgICAgICAgICAgdGFyZ2V0X3ZlcnNpb25maWxlID0gb3MucGF0aC5qb2lu
KGJhc2VfZGlyLCBjZmcudmVyc2lvbmZpbGVfc291cmNlKQogICAgICAgICAg
ICBwcmludCgiVVBEQVRJTkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25maWxlKQog
ICAgICAgICAgICB3cml0ZV90b192ZXJzaW9uX2ZpbGUodGFyZ2V0X3ZlcnNp
b25maWxlLAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgc2Vs
Zi5fdmVyc2lvbmVlcl9nZW5lcmF0ZWRfdmVyc2lvbnMpCiAgICBjbWRzWyJz
ZGlzdCJdID0gY21kX3NkaXN0CgogICAgcmV0dXJuIGNtZHMKCgpDT05GSUdf
RVJST1IgPSAiIiIKc2V0dXAuY2ZnIGlzIG1pc3NpbmcgdGhlIG5lY2Vzc2Fy
eSBWZXJzaW9uZWVyIGNvbmZpZ3VyYXRpb24uIFlvdSBuZWVkCmEgc2VjdGlv
biBsaWtlOgoKIFt2ZXJzaW9uZWVyXQogVkNTID0gZ2l0CiBzdHlsZSA9IHBl
cDQ0MAogdmVyc2lvbmZpbGVfc291cmNlID0gc3JjL215cHJvamVjdC9fdmVy
c2lvbi5weQogdmVyc2lvbmZpbGVfYnVpbGQgPSBteXByb2plY3QvX3ZlcnNp
b24ucHkKIHRhZ19wcmVmaXggPQogcGFyZW50ZGlyX3ByZWZpeCA9IG15cHJv
amVjdC0KCllvdSB3aWxsIGFsc28gbmVlZCB0byBlZGl0IHlvdXIgc2V0dXAu
cHkgdG8gdXNlIHRoZSByZXN1bHRzOgoKIGltcG9ydCB2ZXJzaW9uZWVyCiBz
ZXR1cCh2ZXJzaW9uPXZlcnNpb25lZXIuZ2V0X3ZlcnNpb24oKSwKICAgICAg
IGNtZGNsYXNzPXZlcnNpb25lZXIuZ2V0X2NtZGNsYXNzKCksIC4uLikKClBs
ZWFzZSByZWFkIHRoZSBkb2NzdHJpbmcgaW4gLi92ZXJzaW9uZWVyLnB5IGZv
ciBjb25maWd1cmF0aW9uIGluc3RydWN0aW9ucywKZWRpdCBzZXR1cC5jZmcs
IGFuZCByZS1ydW4gdGhlIGluc3RhbGxlciBvciAncHl0aG9uIHZlcnNpb25l
ZXIucHkgc2V0dXAnLgoiIiIKClNBTVBMRV9DT05GSUcgPSAiIiIKIyBTZWUg
dGhlIGRvY3N0cmluZyBpbiB2ZXJzaW9uZWVyLnB5IGZvciBpbnN0cnVjdGlv
bnMuIE5vdGUgdGhhdCB5b3UgbXVzdAojIHJlLXJ1biAndmVyc2lvbmVlci5w
eSBzZXR1cCcgYWZ0ZXIgY2hhbmdpbmcgdGhpcyBzZWN0aW9uLCBhbmQgY29t
bWl0IHRoZQojIHJlc3VsdGluZyBmaWxlcy4KClt2ZXJzaW9uZWVyXQojVkNT
ID0gZ2l0CiNzdHlsZSA9IHBlcDQ0MAojdmVyc2lvbmZpbGVfc291cmNlID0K
I3ZlcnNpb25maWxlX2J1aWxkID0KI3RhZ19wcmVmaXggPQojcGFyZW50ZGly
X3ByZWZpeCA9CgoiIiIKCklOSVRfUFlfU05JUFBFVCA9ICIiIgpmcm9tIC5f
dmVyc2lvbiBpbXBvcnQgZ2V0X3ZlcnNpb25zCl9fdmVyc2lvbl9fID0gZ2V0
X3ZlcnNpb25zKClbJ3ZlcnNpb24nXQpkZWwgZ2V0X3ZlcnNpb25zCiIiIgoK
CmRlZiBkb19zZXR1cCgpOgogICAgIiIiTWFpbiBWQ1MtaW5kZXBlbmRlbnQg
c2V0dXAgZnVuY3Rpb24gZm9yIGluc3RhbGxpbmcgVmVyc2lvbmVlci4iIiIK
ICAgIHJvb3QgPSBnZXRfcm9vdCgpCiAgICB0cnk6CiAgICAgICAgY2ZnID0g
Z2V0X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAgIGV4Y2VwdCAoRW52aXJv
bm1lbnRFcnJvciwgY29uZmlncGFyc2VyLk5vU2VjdGlvbkVycm9yLAogICAg
ICAgICAgICBjb25maWdwYXJzZXIuTm9PcHRpb25FcnJvcikgYXMgZToKICAg
ICAgICBpZiBpc2luc3RhbmNlKGUsIChFbnZpcm9ubWVudEVycm9yLCBjb25m
aWdwYXJzZXIuTm9TZWN0aW9uRXJyb3IpKToKICAgICAgICAgICAgcHJpbnQo
IkFkZGluZyBzYW1wbGUgdmVyc2lvbmVlciBjb25maWcgdG8gc2V0dXAuY2Zn
IiwKICAgICAgICAgICAgICAgICAgZmlsZT1zeXMuc3RkZXJyKQogICAgICAg
ICAgICB3aXRoIG9wZW4ob3MucGF0aC5qb2luKHJvb3QsICJzZXR1cC5jZmci
KSwgImEiKSBhcyBmOgogICAgICAgICAgICAgICAgZi53cml0ZShTQU1QTEVf
Q09ORklHKQogICAgICAgIHByaW50KENPTkZJR19FUlJPUiwgZmlsZT1zeXMu
c3RkZXJyKQogICAgICAgIHJldHVybiAxCgogICAgcHJpbnQoIiBjcmVhdGlu
ZyAlcyIgJSBjZmcudmVyc2lvbmZpbGVfc291cmNlKQogICAgd2l0aCBvcGVu
KGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UsICJ3IikgYXMgZjoKICAgICAgICBM
T05HID0gTE9OR19WRVJTSU9OX1BZW2NmZy5WQ1NdCiAgICAgICAgZi53cml0
ZShMT05HICUgeyJET0xMQVIiOiAiJCIsCiAgICAgICAgICAgICAgICAgICAg
ICAgICJTVFlMRSI6IGNmZy5zdHlsZSwKICAgICAgICAgICAgICAgICAgICAg
ICAgIlRBR19QUkVGSVgiOiBjZmcudGFnX3ByZWZpeCwKICAgICAgICAgICAg
ICAgICAgICAgICAgIlBBUkVOVERJUl9QUkVGSVgiOiBjZmcucGFyZW50ZGly
X3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgIlZFUlNJT05GSUxF
X1NPVVJDRSI6IGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UsCiAgICAgICAgICAg
ICAgICAgICAgICAgIH0pCgogICAgaXB5ID0gb3MucGF0aC5qb2luKG9zLnBh
dGguZGlybmFtZShjZmcudmVyc2lvbmZpbGVfc291cmNlKSwKICAgICAgICAg
ICAgICAgICAgICAgICAiX19pbml0X18ucHkiKQogICAgaWYgb3MucGF0aC5l
eGlzdHMoaXB5KToKICAgICAgICB0cnk6CiAgICAgICAgICAgIHdpdGggb3Bl
bihpcHksICJyIikgYXMgZjoKICAgICAgICAgICAgICAgIG9sZCA9IGYucmVh
ZCgpCiAgICAgICAgZXhjZXB0IEVudmlyb25tZW50RXJyb3I6CiAgICAgICAg
ICAgIG9sZCA9ICIiCiAgICAgICAgaWYgSU5JVF9QWV9TTklQUEVUIG5vdCBp
biBvbGQ6CiAgICAgICAgICAgIHByaW50KCIgYXBwZW5kaW5nIHRvICVzIiAl
IGlweSkKICAgICAgICAgICAgd2l0aCBvcGVuKGlweSwgImEiKSBhcyBmOgog
ICAgICAgICAgICAgICAgZi53cml0ZShJTklUX1BZX1NOSVBQRVQpCiAgICAg
ICAgZWxzZToKICAgICAgICAgICAgcHJpbnQoIiAlcyB1bm1vZGlmaWVkIiAl
IGlweSkKICAgIGVsc2U6CiAgICAgICAgcHJpbnQoIiAlcyBkb2Vzbid0IGV4
aXN0LCBvayIgJSBpcHkpCiAgICAgICAgaXB5ID0gTm9uZQoKICAgICMgTWFr
ZSBzdXJlIGJvdGggdGhlIHRvcC1sZXZlbCAidmVyc2lvbmVlci5weSIgYW5k
IHZlcnNpb25maWxlX3NvdXJjZQogICAgIyAoUEtHL192ZXJzaW9uLnB5LCB1
c2VkIGJ5IHJ1bnRpbWUgY29kZSkgYXJlIGluIE1BTklGRVNULmluLCBzbwog
ICAgIyB0aGV5J2xsIGJlIGNvcGllZCBpbnRvIHNvdXJjZSBkaXN0cmlidXRp
b25zLiBQaXAgd29uJ3QgYmUgYWJsZSB0bwogICAgIyBpbnN0YWxsIHRoZSBw
YWNrYWdlIHdpdGhvdXQgdGhpcy4KICAgIG1hbmlmZXN0X2luID0gb3MucGF0
aC5qb2luKHJvb3QsICJNQU5JRkVTVC5pbiIpCiAgICBzaW1wbGVfaW5jbHVk
ZXMgPSBzZXQoKQogICAgdHJ5OgogICAgICAgIHdpdGggb3BlbihtYW5pZmVz
dF9pbiwgInIiKSBhcyBmOgogICAgICAgICAgICBmb3IgbGluZSBpbiBmOgog
ICAgICAgICAgICAgICAgaWYgbGluZS5zdGFydHN3aXRoKCJpbmNsdWRlICIp
OgogICAgICAgICAgICAgICAgICAgIGZvciBpbmNsdWRlIGluIGxpbmUuc3Bs
aXQoKVsxOl06CiAgICAgICAgICAgICAgICAgICAgICAgIHNpbXBsZV9pbmNs
dWRlcy5hZGQoaW5jbHVkZSkKICAgIGV4Y2VwdCBFbnZpcm9ubWVudEVycm9y
OgogICAgICAgIHBhc3MKICAgICMgVGhhdCBkb2Vzbid0IGNvdmVyIGV2ZXJ5
dGhpbmcgTUFOSUZFU1QuaW4gY2FuIGRvCiAgICAjIChodHRwOi8vZG9jcy5w
eXRob24ub3JnLzIvZGlzdHV0aWxzL3NvdXJjZWRpc3QuaHRtbCNjb21tYW5k
cyksIHNvCiAgICAjIGl0IG1pZ2h0IGdpdmUgc29tZSBmYWxzZSBuZWdhdGl2
ZXMuIEFwcGVuZGluZyByZWR1bmRhbnQgJ2luY2x1ZGUnCiAgICAjIGxpbmVz
IGlzIHNhZmUsIHRob3VnaC4KICAgIGlmICJ2ZXJzaW9uZWVyLnB5IiBub3Qg
aW4gc2ltcGxlX2luY2x1ZGVzOgogICAgICAgIHByaW50KCIgYXBwZW5kaW5n
ICd2ZXJzaW9uZWVyLnB5JyB0byBNQU5JRkVTVC5pbiIpCiAgICAgICAgd2l0
aCBvcGVuKG1hbmlmZXN0X2luLCAiYSIpIGFzIGY6CiAgICAgICAgICAgIGYu
d3JpdGUoImluY2x1ZGUgdmVyc2lvbmVlci5weVxuIikKICAgIGVsc2U6CiAg
ICAgICAgcHJpbnQoIiAndmVyc2lvbmVlci5weScgYWxyZWFkeSBpbiBNQU5J
RkVTVC5pbiIpCiAgICBpZiBjZmcudmVyc2lvbmZpbGVfc291cmNlIG5vdCBp
biBzaW1wbGVfaW5jbHVkZXM6CiAgICAgICAgcHJpbnQoIiBhcHBlbmRpbmcg
dmVyc2lvbmZpbGVfc291cmNlICgnJXMnKSB0byBNQU5JRkVTVC5pbiIgJQog
ICAgICAgICAgICAgIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UpCiAgICAgICAg
d2l0aCBvcGVuKG1hbmlmZXN0X2luLCAiYSIpIGFzIGY6CiAgICAgICAgICAg
IGYud3JpdGUoImluY2x1ZGUgJXNcbiIgJSBjZmcudmVyc2lvbmZpbGVfc291
cmNlKQogICAgZWxzZToKICAgICAgICBwcmludCgiIHZlcnNpb25maWxlX3Nv
dXJjZSBhbHJlYWR5IGluIE1BTklGRVNULmluIikKCiAgICAjIE1ha2UgVkNT
LXNwZWNpZmljIGNoYW5nZXMuIEZvciBnaXQsIHRoaXMgbWVhbnMgY3JlYXRp
bmcvY2hhbmdpbmcKICAgICMgLmdpdGF0dHJpYnV0ZXMgdG8gbWFyayBfdmVy
c2lvbi5weSBmb3IgZXhwb3J0LXN1YnN0IGtleXdvcmQKICAgICMgc3Vic3Rp
dHV0aW9uLgogICAgZG9fdmNzX2luc3RhbGwobWFuaWZlc3RfaW4sIGNmZy52
ZXJzaW9uZmlsZV9zb3VyY2UsIGlweSkKICAgIHJldHVybiAwCgoKZGVmIHNj
YW5fc2V0dXBfcHkoKToKICAgICIiIlZhbGlkYXRlIHRoZSBjb250ZW50cyBv
ZiBzZXR1cC5weSBhZ2FpbnN0IFZlcnNpb25lZXIncyBleHBlY3RhdGlvbnMu
IiIiCiAgICBmb3VuZCA9IHNldCgpCiAgICBzZXR0ZXJzID0gRmFsc2UKICAg
IGVycm9ycyA9IDAKICAgIHdpdGggb3Blbigic2V0dXAucHkiLCAiciIpIGFz
IGY6CiAgICAgICAgZm9yIGxpbmUgaW4gZi5yZWFkbGluZXMoKToKICAgICAg
ICAgICAgaWYgImltcG9ydCB2ZXJzaW9uZWVyIiBpbiBsaW5lOgogICAgICAg
ICAgICAgICAgZm91bmQuYWRkKCJpbXBvcnQiKQogICAgICAgICAgICBpZiAi
dmVyc2lvbmVlci5nZXRfY21kY2xhc3MoKSIgaW4gbGluZToKICAgICAgICAg
ICAgICAgIGZvdW5kLmFkZCgiY21kY2xhc3MiKQogICAgICAgICAgICBpZiAi
dmVyc2lvbmVlci5nZXRfdmVyc2lvbigpIiBpbiBsaW5lOgogICAgICAgICAg
ICAgICAgZm91bmQuYWRkKCJnZXRfdmVyc2lvbiIpCiAgICAgICAgICAgIGlm
ICJ2ZXJzaW9uZWVyLlZDUyIgaW4gbGluZToKICAgICAgICAgICAgICAgIHNl
dHRlcnMgPSBUcnVlCiAgICAgICAgICAgIGlmICJ2ZXJzaW9uZWVyLnZlcnNp
b25maWxlX3NvdXJjZSIgaW4gbGluZToKICAgICAgICAgICAgICAgIHNldHRl
cnMgPSBUcnVlCiAgICBpZiBsZW4oZm91bmQpICE9IDM6CiAgICAgICAgcHJp
bnQoIiIpCiAgICAgICAgcHJpbnQoIllvdXIgc2V0dXAucHkgYXBwZWFycyB0
byBiZSBtaXNzaW5nIHNvbWUgaW1wb3J0YW50IGl0ZW1zIikKICAgICAgICBw
cmludCgiKGJ1dCBJIG1pZ2h0IGJlIHdyb25nKS4gUGxlYXNlIG1ha2Ugc3Vy
ZSBpdCBoYXMgc29tZXRoaW5nIikKICAgICAgICBwcmludCgicm91Z2hseSBs
aWtlIHRoZSBmb2xsb3dpbmc6IikKICAgICAgICBwcmludCgiIikKICAgICAg
ICBwcmludCgiIGltcG9ydCB2ZXJzaW9uZWVyIikKICAgICAgICBwcmludCgi
IHNldHVwKCB2ZXJzaW9uPXZlcnNpb25lZXIuZ2V0X3ZlcnNpb24oKSwiKQog
ICAgICAgIHByaW50KCIgICAgICAgIGNtZGNsYXNzPXZlcnNpb25lZXIuZ2V0
X2NtZGNsYXNzKCksICAuLi4pIikKICAgICAgICBwcmludCgiIikKICAgICAg
ICBlcnJvcnMgKz0gMQogICAgaWYgc2V0dGVyczoKICAgICAgICBwcmludCgi
WW91IHNob3VsZCByZW1vdmUgbGluZXMgbGlrZSAndmVyc2lvbmVlci5WQ1Mg
PSAnIGFuZCIpCiAgICAgICAgcHJpbnQoIid2ZXJzaW9uZWVyLnZlcnNpb25m
aWxlX3NvdXJjZSA9ICcgLiBUaGlzIGNvbmZpZ3VyYXRpb24iKQogICAgICAg
IHByaW50KCJub3cgbGl2ZXMgaW4gc2V0dXAuY2ZnLCBhbmQgc2hvdWxkIGJl
IHJlbW92ZWQgZnJvbSBzZXR1cC5weSIpCiAgICAgICAgcHJpbnQoIiIpCiAg
ICAgICAgZXJyb3JzICs9IDEKICAgIHJldHVybiBlcnJvcnMKCgppZiBfX25h
bWVfXyA9PSAiX19tYWluX18iOgogICAgY21kID0gc3lzLmFyZ3ZbMV0KICAg
IGlmIGNtZCA9PSAic2V0dXAiOgogICAgICAgIGVycm9ycyA9IGRvX3NldHVw
KCkKICAgICAgICBlcnJvcnMgKz0gc2Nhbl9zZXR1cF9weSgpCiAgICAgICAg
aWYgZXJyb3JzOgogICAgICAgICAgICBzeXMuZXhpdCgxKQo=

"""
newver = "0.18.1"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
